
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         sparql_parser_parse
#define yylex           sparql_parser_lex
#define yyerror         sparql_parser_error
#define yylval          sparql_parser_lval
#define yychar          sparql_parser_char
#define yydebug         sparql_parser_debug
#define yynerrs         sparql_parser_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 28 "./sparql_parser.y"

#ifdef HAVE_CONFIG_H
#include <rasqal_config.h>
#endif

#ifdef WIN32
#include <win32_rasqal_config.h>
#endif

#include <stdio.h>
#include <stdarg.h>

#include <rasqal.h>
#include <rasqal_internal.h>

#include <sparql_parser.h>

#define YY_DECL int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t yyscanner)
#define YY_NO_UNISTD_H 1
#include <sparql_lexer.h>

#include <sparql_common.h>


#if 0
#undef RASQAL_DEBUG
#define RASQAL_DEBUG 3
#endif


#define DEBUG_FH stderr

/* Make verbose error messages for syntax errors */
#define YYERROR_VERBOSE 1

/* Fail with an debug error message if RASQAL_DEBUG > 1 */
#if RASQAL_DEBUG > 1
#define YYERROR_MSG(msg) do { fputs("** YYERROR ", DEBUG_FH); fputs(msg, DEBUG_FH); fputc('\n', DEBUG_FH); YYERROR; } while(0)
#else
#define YYERROR_MSG(ignore) YYERROR
#endif

/* Slow down the grammar operation and watch it work */
#if RASQAL_DEBUG > 2
#define YYDEBUG 1
#endif

/* the lexer does not seem to track this */
#undef RASQAL_SPARQL_USE_ERROR_COLUMNS

/* Missing sparql_lexer.c/h prototypes */
int sparql_lexer_get_column(yyscan_t yyscanner);
/* Not used here */
/* void sparql_lexer_set_column(int  column_no , yyscan_t yyscanner);*/


/* What the lexer wants */
extern int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t scanner);
#define YYLEX_PARAM ((rasqal_sparql_query_language*)(((rasqal_query*)rq)->context))->scanner

/* Pure parser argument (a void*) */
#define YYPARSE_PARAM rq

/* Make the yyerror below use the rdf_parser */
#undef yyerror
#define yyerror(message) sparql_query_error((rasqal_query*)rq, message)

/* Make lex/yacc interface as small as possible */
#undef yylex
#define yylex sparql_lexer_lex


static int sparql_parse(rasqal_query* rq);
static void sparql_query_error(rasqal_query* rq, const char *message);
static void sparql_query_error_full(rasqal_query *rq, const char *message, ...) RASQAL_PRINTF_FORMAT(2, 3);



/* Line 189 of yacc.c  */
#line 160 "sparql_parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SELECT = 258,
     FROM = 259,
     WHERE = 260,
     OPTIONAL = 261,
     DESCRIBE = 262,
     CONSTRUCT = 263,
     ASK = 264,
     DISTINCT = 265,
     REDUCED = 266,
     LIMIT = 267,
     UNION = 268,
     PREFIX = 269,
     BASE = 270,
     BOUND = 271,
     GRAPH = 272,
     NAMED = 273,
     FILTER = 274,
     OFFSET = 275,
     ORDER = 276,
     BY = 277,
     REGEX = 278,
     ASC = 279,
     DESC = 280,
     LANGMATCHES = 281,
     A = 282,
     STRLANG = 283,
     STRDT = 284,
     STR = 285,
     IRI = 286,
     URI = 287,
     BNODE = 288,
     LANG = 289,
     DATATYPE = 290,
     ISURI = 291,
     ISBLANK = 292,
     ISLITERAL = 293,
     ISNUMERIC = 294,
     SAMETERM = 295,
     GROUP = 296,
     HAVING = 297,
     COUNT = 298,
     SUM = 299,
     AVG = 300,
     MIN = 301,
     MAX = 302,
     GROUP_CONCAT = 303,
     SAMPLE = 304,
     SEPARATOR = 305,
     DELETE = 306,
     INSERT = 307,
     WITH = 308,
     CLEAR = 309,
     CREATE = 310,
     SILENT = 311,
     DATA = 312,
     DROP = 313,
     LOAD = 314,
     INTO = 315,
     DEFAULT = 316,
     COALESCE = 317,
     AS = 318,
     IF = 319,
     NOT = 320,
     IN = 321,
     BINDINGS = 322,
     UNDEF = 323,
     SERVICE = 324,
     MINUS = 325,
     EXPLAIN = 326,
     LET = 327,
     SC_OR = 328,
     SC_AND = 329,
     EQ = 330,
     NEQ = 331,
     LT = 332,
     GT = 333,
     LE = 334,
     GE = 335,
     ASSIGN = 336,
     STRING_LITERAL = 337,
     DOUBLE_LITERAL = 338,
     DOUBLE_POSITIVE_LITERAL = 339,
     DOUBLE_NEGATIVE_LITERAL = 340,
     INTEGER_LITERAL = 341,
     INTEGER_POSITIVE_LITERAL = 342,
     INTEGER_NEGATIVE_LITERAL = 343,
     DECIMAL_LITERAL = 344,
     DECIMAL_POSITIVE_LITERAL = 345,
     DECIMAL_NEGATIVE_LITERAL = 346,
     BOOLEAN_LITERAL = 347,
     URI_LITERAL = 348,
     URI_LITERAL_BRACE = 349,
     QNAME_LITERAL = 350,
     QNAME_LITERAL_BRACE = 351,
     BLANK_LITERAL = 352,
     IDENTIFIER = 353
   };
#endif
/* Tokens.  */
#define SELECT 258
#define FROM 259
#define WHERE 260
#define OPTIONAL 261
#define DESCRIBE 262
#define CONSTRUCT 263
#define ASK 264
#define DISTINCT 265
#define REDUCED 266
#define LIMIT 267
#define UNION 268
#define PREFIX 269
#define BASE 270
#define BOUND 271
#define GRAPH 272
#define NAMED 273
#define FILTER 274
#define OFFSET 275
#define ORDER 276
#define BY 277
#define REGEX 278
#define ASC 279
#define DESC 280
#define LANGMATCHES 281
#define A 282
#define STRLANG 283
#define STRDT 284
#define STR 285
#define IRI 286
#define URI 287
#define BNODE 288
#define LANG 289
#define DATATYPE 290
#define ISURI 291
#define ISBLANK 292
#define ISLITERAL 293
#define ISNUMERIC 294
#define SAMETERM 295
#define GROUP 296
#define HAVING 297
#define COUNT 298
#define SUM 299
#define AVG 300
#define MIN 301
#define MAX 302
#define GROUP_CONCAT 303
#define SAMPLE 304
#define SEPARATOR 305
#define DELETE 306
#define INSERT 307
#define WITH 308
#define CLEAR 309
#define CREATE 310
#define SILENT 311
#define DATA 312
#define DROP 313
#define LOAD 314
#define INTO 315
#define DEFAULT 316
#define COALESCE 317
#define AS 318
#define IF 319
#define NOT 320
#define IN 321
#define BINDINGS 322
#define UNDEF 323
#define SERVICE 324
#define MINUS 325
#define EXPLAIN 326
#define LET 327
#define SC_OR 328
#define SC_AND 329
#define EQ 330
#define NEQ 331
#define LT 332
#define GT 333
#define LE 334
#define GE 335
#define ASSIGN 336
#define STRING_LITERAL 337
#define DOUBLE_LITERAL 338
#define DOUBLE_POSITIVE_LITERAL 339
#define DOUBLE_NEGATIVE_LITERAL 340
#define INTEGER_LITERAL 341
#define INTEGER_POSITIVE_LITERAL 342
#define INTEGER_NEGATIVE_LITERAL 343
#define DECIMAL_LITERAL 344
#define DECIMAL_POSITIVE_LITERAL 345
#define DECIMAL_NEGATIVE_LITERAL 346
#define BOOLEAN_LITERAL 347
#define URI_LITERAL 348
#define URI_LITERAL_BRACE 349
#define QNAME_LITERAL 350
#define QNAME_LITERAL_BRACE 351
#define BLANK_LITERAL 352
#define IDENTIFIER 353




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 114 "./sparql_parser.y"

  raptor_sequence *seq;
  rasqal_variable *variable;
  rasqal_literal *literal;
  rasqal_triple *triple;
  rasqal_expression *expr;
  rasqal_graph_pattern *graph_pattern;
  double floating;
  raptor_uri *uri;
  unsigned char *name;
  rasqal_formula *formula;
  rasqal_update_operation *update;
  unsigned int uinteger;
  rasqal_data_graph* data_graph;
  rasqal_row* row;
  rasqal_solution_modifier* modifier;
  int limit_offset[2];
  int integer;
  rasqal_projection* projection;
  rasqal_bindings* bindings;



/* Line 214 of yacc.c  */
#line 416 "sparql_parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 428 "sparql_parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1633

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  115
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  135
/* YYNRULES -- Number of rules.  */
#define YYNRULES  315
/* YYNRULES -- Number of states.  */
#define YYNSTATES  579

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   353

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   114,     2,     2,    81,     2,     2,     2,
      74,    75,    92,    90,    73,    91,   113,    93,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   112,
       2,     2,     2,    80,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    76,     2,    77,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    78,     2,    79,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    82,    83,
      84,    85,    86,    87,    88,    89,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     7,     9,    10,    12,    14,    16,    18,
      20,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      42,    45,    46,    51,    52,    58,    62,    66,    70,    73,
      75,    77,    80,    84,    86,    88,    94,    96,    98,   100,
     102,   104,   106,   108,   110,   111,   113,   115,   121,   127,
     133,   139,   145,   150,   151,   155,   157,   164,   170,   176,
     182,   188,   191,   195,   197,   201,   204,   207,   209,   211,
     215,   221,   227,   229,   235,   241,   243,   245,   248,   250,
     254,   260,   266,   278,   286,   294,   302,   306,   308,   311,
     315,   319,   324,   327,   331,   335,   340,   343,   345,   348,
     353,   356,   358,   360,   361,   363,   366,   368,   371,   373,
     375,   376,   381,   384,   386,   388,   390,   396,   398,   402,
     403,   405,   408,   410,   413,   414,   417,   420,   422,   424,
     425,   429,   430,   433,   435,   438,   441,   443,   445,   447,
     449,   452,   455,   461,   462,   465,   467,   469,   470,   473,
     475,   479,   482,   485,   487,   489,   491,   493,   495,   497,
     501,   505,   508,   510,   511,   514,   516,   517,   521,   523,
     525,   527,   528,   532,   534,   536,   538,   540,   542,   544,
     546,   549,   553,   557,   560,   564,   566,   570,   572,   579,
     582,   584,   586,   588,   590,   591,   598,   602,   605,   609,
     613,   615,   616,   620,   622,   623,   627,   629,   632,   635,
     639,   642,   643,   645,   646,   649,   652,   653,   655,   657,
     659,   661,   663,   667,   671,   674,   676,   678,   680,   682,
     684,   686,   688,   691,   694,   696,   699,   702,   704,   706,
     708,   710,   712,   714,   717,   719,   723,   725,   729,   731,
     735,   739,   743,   747,   751,   755,   759,   764,   766,   770,
     774,   777,   780,   782,   786,   790,   792,   795,   798,   801,
     803,   805,   807,   809,   811,   813,   815,   819,   824,   829,
     836,   841,   846,   851,   856,   861,   865,   867,   876,   883,
     890,   897,   902,   907,   912,   917,   919,   926,   935,   937,
     939,   941,   943,   945,   947,   949,   951,   953,   955,   957,
     959,   961,   963,   965,   967,   969
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     116,     0,    -1,   121,   117,   118,    -1,    71,    -1,    -1,
     124,    -1,   142,    -1,   143,    -1,   145,    -1,   119,    -1,
     119,   120,    -1,   120,    -1,   148,    -1,   153,    -1,   154,
      -1,   155,    -1,   156,    -1,   157,    -1,   159,    -1,   122,
     123,    -1,    15,   106,    -1,    -1,   123,    14,   111,   106,
      -1,    -1,   126,   161,   165,   167,   180,    -1,   126,   165,
     167,    -1,     3,    10,   127,    -1,     3,    11,   127,    -1,
       3,   127,    -1,   128,    -1,    92,    -1,   128,   129,    -1,
     128,    73,   129,    -1,   129,    -1,   228,    -1,    74,   232,
      63,   230,    75,    -1,   133,    -1,   134,    -1,   135,    -1,
     136,    -1,   137,    -1,   140,    -1,   141,    -1,    10,    -1,
      -1,   232,    -1,    92,    -1,    43,    74,   131,   132,    75,
      -1,    44,    74,   131,   232,    75,    -1,    45,    74,   131,
     232,    75,    -1,    46,    74,   131,   232,    75,    -1,    47,
      74,   131,   232,    75,    -1,   112,    50,    84,    95,    -1,
      -1,   139,    73,   232,    -1,   232,    -1,    48,    74,   131,
     139,   138,    75,    -1,    49,    74,   131,   232,    75,    -1,
       8,   210,   161,   165,   167,    -1,     7,   144,   161,   166,
     167,    -1,     7,    92,   161,   166,   167,    -1,   144,   227,
      -1,   144,    73,   227,    -1,   227,    -1,     9,   161,   165,
      -1,     4,   162,    -1,     4,   163,    -1,   106,    -1,    61,
      -1,    51,   160,   166,    -1,    51,    78,   152,    79,   165,
      -1,    51,    57,    78,   149,    79,    -1,   194,    -1,    17,
     106,    78,   194,    79,    -1,    17,   227,    78,   212,    79,
      -1,   212,    -1,   150,    -1,   152,   151,    -1,   151,    -1,
      52,   160,   166,    -1,    52,    78,   152,    79,   166,    -1,
      52,    57,    78,   149,    79,    -1,    53,   106,    51,    78,
     152,    79,    52,    78,   152,    79,   166,    -1,    53,   106,
      51,    78,   152,    79,   166,    -1,    53,   106,    52,    78,
     152,    79,   166,    -1,    53,   106,    52,    57,    78,   149,
      79,    -1,    54,    17,   147,    -1,    54,    -1,    55,   106,
      -1,    55,    56,   106,    -1,    55,    17,   106,    -1,    55,
      56,    17,   106,    -1,    58,   106,    -1,    58,    56,   106,
      -1,    58,    17,   106,    -1,    58,    56,    17,   106,    -1,
     158,   106,    -1,   106,    -1,    59,   158,    -1,    59,   158,
      60,   147,    -1,   160,   146,    -1,   146,    -1,   160,    -1,
      -1,   164,    -1,    18,   164,    -1,   248,    -1,     5,   187,
      -1,   187,    -1,   165,    -1,    -1,   170,   173,   175,   174,
      -1,   168,   169,    -1,   169,    -1,   241,    -1,   206,    -1,
      74,   232,    63,   228,    75,    -1,   228,    -1,    41,    22,
     168,    -1,    -1,   204,    -1,   172,   171,    -1,   171,    -1,
      42,   172,    -1,    -1,   178,   179,    -1,   179,   178,    -1,
     178,    -1,   179,    -1,    -1,    21,    22,   176,    -1,    -1,
     176,   177,    -1,   177,    -1,    24,   240,    -1,    25,   240,
      -1,   206,    -1,   228,    -1,   240,    -1,   241,    -1,    12,
      99,    -1,    20,    99,    -1,    67,   181,    78,   182,    79,
      -1,    -1,   181,   228,    -1,   228,    -1,   183,    -1,    -1,
     183,   184,    -1,   184,    -1,    74,   185,    75,    -1,    74,
      75,    -1,   185,   186,    -1,   186,    -1,   248,    -1,    95,
      -1,   244,    -1,   105,    -1,    68,    -1,    78,   125,    79,
      -1,    78,   188,    79,    -1,   189,   190,    -1,   194,    -1,
      -1,   190,   191,    -1,   191,    -1,    -1,   192,   193,   189,
      -1,   195,    -1,   203,    -1,   113,    -1,    -1,   213,   113,
     189,    -1,   213,    -1,   200,    -1,   196,    -1,   199,    -1,
     197,    -1,   198,    -1,   202,    -1,     6,   187,    -1,    17,
     227,   187,    -1,    69,   227,   187,    -1,    70,   187,    -1,
     187,    13,   201,    -1,   187,    -1,   201,    13,   187,    -1,
     187,    -1,    72,    74,   228,    94,   232,    75,    -1,    19,
     204,    -1,   240,    -1,   241,    -1,   206,    -1,   112,    -1,
      -1,   248,    74,   131,   209,   205,    75,    -1,   243,   209,
      75,    -1,    62,   208,    -1,    74,   209,    75,    -1,   209,
      73,   232,    -1,   232,    -1,    -1,    78,   211,    79,    -1,
     212,    -1,    -1,   213,   113,   211,    -1,   213,    -1,   226,
     214,    -1,   221,   216,    -1,   220,   217,   215,    -1,   112,
     216,    -1,    -1,   214,    -1,    -1,   219,   218,    -1,    73,
     217,    -1,    -1,   225,    -1,   227,    -1,    27,    -1,   223,
      -1,   222,    -1,    76,   214,    77,    -1,    74,   224,    75,
      -1,   224,   225,    -1,   225,    -1,   226,    -1,   221,    -1,
     228,    -1,   231,    -1,   228,    -1,   248,    -1,    80,   229,
      -1,    81,   229,    -1,   111,    -1,    80,   229,    -1,    81,
     229,    -1,   229,    -1,   248,    -1,    95,    -1,   244,    -1,
     105,    -1,   249,    -1,    74,    75,    -1,   233,    -1,   233,
      82,   234,    -1,   234,    -1,   234,    83,   235,    -1,   235,
      -1,   236,    84,   236,    -1,   236,    85,   236,    -1,   236,
      86,   236,    -1,   236,    87,   236,    -1,   236,    88,   236,
      -1,   236,    89,   236,    -1,   236,    66,   208,    -1,   236,
      65,    66,   208,    -1,   236,    -1,   237,    90,   236,    -1,
     237,    91,   236,    -1,   237,   246,    -1,   237,   247,    -1,
     237,    -1,   238,    92,   237,    -1,   238,    93,   237,    -1,
     238,    -1,   114,   239,    -1,    90,   239,    -1,    91,   239,
      -1,   239,    -1,   240,    -1,   241,    -1,   206,    -1,   231,
      -1,   228,    -1,   130,    -1,    74,   232,    75,    -1,    30,
      74,   232,    75,    -1,    34,    74,   232,    75,    -1,    26,
      74,   232,    73,   232,    75,    -1,    35,    74,   232,    75,
      -1,    16,    74,   228,    75,    -1,    31,    74,   232,    75,
      -1,    32,    74,   232,    75,    -1,    33,    74,   232,    75,
      -1,    33,    74,    75,    -1,   207,    -1,    64,    74,   232,
      73,   232,    73,   232,    75,    -1,    28,    74,   232,    73,
     232,    75,    -1,    29,    74,   232,    73,   232,    75,    -1,
      40,    74,   232,    73,   232,    75,    -1,    36,    74,   232,
      75,    -1,    37,    74,   232,    75,    -1,    38,    74,   232,
      75,    -1,    39,    74,   232,    75,    -1,   242,    -1,    23,
      74,   232,    73,   232,    75,    -1,    23,    74,   232,    73,
     232,    73,   232,    75,    -1,   107,    -1,   109,    -1,   245,
      -1,   246,    -1,   247,    -1,    99,    -1,   102,    -1,    96,
      -1,   100,    -1,   103,    -1,    97,    -1,   101,    -1,   104,
      -1,    98,    -1,   106,    -1,   108,    -1,   110,    -1,    76,
      77,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   441,   441,   447,   459,   466,   471,   476,   481,   485,
     489,   490,   494,   498,   502,   506,   510,   514,   518,   526,
     534,   539,   546,   576,   583,   607,   618,   623,   628,   638,
     642,   652,   661,   670,   693,   697,   737,   741,   745,   749,
     753,   757,   761,   768,   779,   785,   789,   797,   817,   837,
     857,   877,   897,   902,   911,   920,   941,   968,   989,  1005,
    1018,  1035,  1044,  1053,  1074,  1086,  1090,  1098,  1102,  1110,
    1128,  1157,  1179,  1195,  1215,  1230,  1237,  1245,  1258,  1282,
    1300,  1327,  1345,  1367,  1388,  1409,  1430,  1454,  1486,  1510,
    1534,  1562,  1594,  1618,  1643,  1671,  1703,  1712,  1736,  1766,
    1802,  1808,  1821,  1826,  1833,  1857,  1880,  1888,  1892,  1900,
    1905,  1912,  1926,  1936,  1961,  1965,  1969,  1989,  2003,  2017,
    2024,  2031,  2041,  2066,  2080,  2087,  2092,  2097,  2102,  2108,
    2116,  2121,  2128,  2138,  2163,  2170,  2177,  2185,  2202,  2210,
    2222,  2236,  2249,  2263,  2270,  2279,  2301,  2306,  2313,  2325,
    2350,  2374,  2382,  2391,  2415,  2419,  2423,  2427,  2431,  2442,
    2446,  2457,  2515,  2529,  2541,  2578,  2583,  2595,  2643,  2656,
    2684,  2685,  2690,  2721,  2729,  2733,  2737,  2741,  2745,  2749,
    2757,  2801,  2856,  2870,  2880,  2895,  2902,  2912,  2942,  2963,
    2971,  2975,  2979,  2986,  2991,  2998,  3042,  3081,  3110,  3117,
    3127,  3149,  3156,  3164,  3169,  3185,  3220,  3235,  3279,  3327,
    3430,  3435,  3442,  3447,  3454,  3537,  3542,  3549,  3557,  3567,
    3599,  3603,  3611,  3678,  3810,  3868,  3910,  3914,  3922,  3934,
    3947,  3953,  3961,  3965,  3972,  3983,  3987,  3991,  4001,  4005,
    4009,  4013,  4017,  4021,  4031,  4039,  4046,  4054,  4062,  4071,
    4078,  4085,  4092,  4099,  4106,  4113,  4118,  4123,  4132,  4139,
    4146,  4159,  4172,  4179,  4186,  4193,  4201,  4208,  4212,  4219,
    4233,  4237,  4241,  4250,  4256,  4266,  4274,  4282,  4289,  4296,
    4303,  4310,  4325,  4332,  4339,  4346,  4353,  4357,  4364,  4371,
    4378,  4385,  4392,  4399,  4406,  4413,  4421,  4428,  4442,  4448,
    4468,  4472,  4476,  4483,  4487,  4491,  4499,  4503,  4507,  4515,
    4519,  4523,  4535,  4541,  4561,  4567
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SELECT", "FROM", "WHERE", "OPTIONAL",
  "DESCRIBE", "CONSTRUCT", "ASK", "DISTINCT", "REDUCED", "LIMIT", "UNION",
  "PREFIX", "BASE", "BOUND", "GRAPH", "NAMED", "FILTER", "OFFSET", "ORDER",
  "BY", "REGEX", "ASC", "DESC", "LANGMATCHES", "\"a\"", "\"strlang\"",
  "\"strdt\"", "\"str\"", "\"iri\"", "\"uri\"", "\"bnode\"", "\"lang\"",
  "\"datatype\"", "\"isUri\"", "\"isBlank\"", "\"isLiteral\"",
  "\"isNumeric\"", "\"sameTerm\"", "GROUP", "HAVING", "COUNT", "SUM",
  "AVG", "MIN", "MAX", "GROUP_CONCAT", "SAMPLE", "SEPARATOR", "DELETE",
  "INSERT", "WITH", "CLEAR", "CREATE", "SILENT", "DATA", "DROP", "LOAD",
  "INTO", "DEFAULT", "COALESCE", "AS", "IF", "NOT", "IN", "BINDINGS",
  "UNDEF", "SERVICE", "MINUS", "EXPLAIN", "LET", "','", "'('", "')'",
  "'['", "']'", "'{'", "'}'", "'?'", "'$'", "SC_OR", "SC_AND", "EQ", "NEQ",
  "LT", "GT", "LE", "GE", "'+'", "'-'", "'*'", "'/'", "\":=\"",
  "\"string literal\"", "\"double literal\"",
  "\"double positive literal\"", "\"double negative literal\"",
  "\"integer literal\"", "\"integer positive literal\"",
  "\"integer negative literal\"", "\"decimal literal\"",
  "\"decimal positive literal\"", "\"decimal negative literal\"",
  "\"boolean literal\"", "\"URI literal\"", "\"URI literal (\"",
  "\"QName literal\"", "\"QName literal (\"", "\"blank node literal\"",
  "\"identifier\"", "';'", "'.'", "'!'", "$accept", "Query", "ExplainOpt",
  "ReportFormat", "UpdateOperationList", "UpdateOperation", "Prologue",
  "BaseDeclOpt", "PrefixDeclListOpt", "SelectQuery", "SubSelect",
  "SelectClause", "SelectExpressionList", "SelectExpressionListTail",
  "SelectTerm", "AggregateExpression", "DistinctOpt", "ExpressionOrStar",
  "CountAggregateExpression", "SumAggregateExpression",
  "AvgAggregateExpression", "MinAggregateExpression",
  "MaxAggregateExpression", "SeparatorOpt", "ExpressionList",
  "GroupConcatAggregateExpression", "SampleAggregateExpression",
  "ConstructQuery", "DescribeQuery", "VarOrIRIrefList", "AskQuery",
  "DatasetClause", "GraphRef", "DeleteQuery", "GraphTriples",
  "GraphTemplate", "ModifyTemplate", "ModifyTemplateList", "InsertQuery",
  "UpdateQuery", "ClearQuery", "CreateQuery", "DropQuery", "IriRefList",
  "LoadQuery", "DatasetClauseList", "DatasetClauseListOpt",
  "DefaultGraphClause", "NamedGraphClause", "SourceSelector",
  "WhereClause", "WhereClauseOpt", "SolutionModifier",
  "GroupConditionList", "GroupCondition", "GroupClauseOpt",
  "HavingCondition", "HavingConditionList", "HavingClauseOpt",
  "LimitOffsetClausesOpt", "OrderClauseOpt", "OrderConditionList",
  "OrderCondition", "LimitClause", "OffsetClause", "BindingsClauseOpt",
  "VarList", "BindingsRowListOpt", "BindingsRowList", "BindingsRow",
  "BindingValueList", "BindingValue", "GroupGraphPattern",
  "GroupGraphPatternSub", "TriplesBlockOpt", "GraphPatternListOpt",
  "GraphPatternList", "GraphPatternListFilter", "DotOptional",
  "TriplesBlock", "GraphPatternNotTriples", "OptionalGraphPattern",
  "GraphGraphPattern", "ServiceGraphPattern", "MinusGraphPattern",
  "GroupOrUnionGraphPattern", "GroupOrUnionGraphPatternList",
  "LetGraphPattern", "Filter", "Constraint", "ParamsOpt", "FunctionCall",
  "CoalesceExpression", "ArgList", "ArgListNoBraces", "ConstructTemplate",
  "ConstructTriplesOpt", "ConstructTriples", "TriplesSameSubject",
  "PropertyListNotEmpty", "PropertyListTailOpt", "PropertyList",
  "ObjectList", "ObjectTail", "Object", "Verb", "TriplesNode",
  "BlankNodePropertyList", "Collection", "GraphNodeListNotEmpty",
  "GraphNode", "VarOrTerm", "VarOrIRIref", "Var", "VarName",
  "VarOrBadVarName", "GraphTerm", "Expression", "ConditionalOrExpression",
  "ConditionalAndExpression", "RelationalExpression", "AdditiveExpression",
  "MultiplicativeExpression", "UnaryExpression", "PrimaryExpression",
  "BrackettedExpression", "BuiltInCall", "RegexExpression", "IRIrefBrace",
  "NumericLiteral", "NumericLiteralUnsigned", "NumericLiteralPositive",
  "NumericLiteralNegative", "IRIref", "BlankNode", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,    44,    40,    41,    91,    93,   123,   125,
      63,    36,   328,   329,   330,   331,   332,   333,   334,   335,
      43,    45,    42,    47,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,    59,    46,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   115,   116,   117,   117,   118,   118,   118,   118,   118,
     119,   119,   120,   120,   120,   120,   120,   120,   120,   121,
     122,   122,   123,   123,   124,   125,   126,   126,   126,   127,
     127,   128,   128,   128,   129,   129,   130,   130,   130,   130,
     130,   130,   130,   131,   131,   132,   132,   133,   134,   135,
     136,   137,   138,   138,   139,   139,   140,   141,   142,   143,
     143,   144,   144,   144,   145,   146,   146,   147,   147,   148,
     148,   148,   149,   149,   150,   151,   151,   152,   152,   153,
     153,   153,   154,   154,   154,   154,   155,   155,   156,   156,
     156,   156,   157,   157,   157,   157,   158,   158,   159,   159,
     160,   160,   161,   161,   162,   163,   164,   165,   165,   166,
     166,   167,   168,   168,   169,   169,   169,   169,   170,   170,
     171,   172,   172,   173,   173,   174,   174,   174,   174,   174,
     175,   175,   176,   176,   177,   177,   177,   177,   177,   177,
     178,   179,   180,   180,   181,   181,   182,   182,   183,   183,
     184,   184,   185,   185,   186,   186,   186,   186,   186,   187,
     187,   188,   189,   189,   190,   190,   190,   191,   192,   192,
     193,   193,   194,   194,   195,   195,   195,   195,   195,   195,
     196,   197,   198,   199,   200,   200,   201,   201,   202,   203,
     204,   204,   204,   205,   205,   206,   206,   207,   208,   209,
     209,   209,   210,   211,   211,   212,   212,   213,   213,   214,
     215,   215,   216,   216,   217,   218,   218,   219,   220,   220,
     221,   221,   222,   223,   224,   224,   225,   225,   226,   226,
     227,   227,   228,   228,   229,   230,   230,   230,   231,   231,
     231,   231,   231,   231,   232,   233,   233,   234,   234,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   236,   236,
     236,   236,   236,   237,   237,   237,   238,   238,   238,   238,
     239,   239,   239,   239,   239,   239,   240,   241,   241,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   241,   241,   241,   241,   242,   242,   243,   243,
     244,   244,   244,   245,   245,   245,   246,   246,   246,   247,
     247,   247,   248,   248,   249,   249
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     1,     0,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     4,     0,     5,     3,     3,     3,     2,     1,
       1,     2,     3,     1,     1,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     5,     5,     5,
       5,     5,     4,     0,     3,     1,     6,     5,     5,     5,
       5,     2,     3,     1,     3,     2,     2,     1,     1,     3,
       5,     5,     1,     5,     5,     1,     1,     2,     1,     3,
       5,     5,    11,     7,     7,     7,     3,     1,     2,     3,
       3,     4,     2,     3,     3,     4,     2,     1,     2,     4,
       2,     1,     1,     0,     1,     2,     1,     2,     1,     1,
       0,     4,     2,     1,     1,     1,     5,     1,     3,     0,
       1,     2,     1,     2,     0,     2,     2,     1,     1,     0,
       3,     0,     2,     1,     2,     2,     1,     1,     1,     1,
       2,     2,     5,     0,     2,     1,     1,     0,     2,     1,
       3,     2,     2,     1,     1,     1,     1,     1,     1,     3,
       3,     2,     1,     0,     2,     1,     0,     3,     1,     1,
       1,     0,     3,     1,     1,     1,     1,     1,     1,     1,
       2,     3,     3,     2,     3,     1,     3,     1,     6,     2,
       1,     1,     1,     1,     0,     6,     3,     2,     3,     3,
       1,     0,     3,     1,     0,     3,     1,     2,     2,     3,
       2,     0,     1,     0,     2,     2,     0,     1,     1,     1,
       1,     1,     3,     3,     2,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     2,     1,     3,     1,     3,     1,     3,
       3,     3,     3,     3,     3,     3,     4,     1,     3,     3,
       2,     2,     1,     3,     3,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     3,     4,     4,     6,
       4,     4,     4,     4,     4,     3,     1,     8,     6,     6,
       6,     4,     4,     4,     4,     1,     6,     8,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      21,     0,     0,     4,    23,    20,     1,     3,     0,    19,
       0,     0,     0,   103,     0,     0,     0,    87,     0,     0,
       0,     2,     9,    11,     5,   103,     6,     7,     8,    12,
      13,    14,    15,    16,    17,    18,     0,     0,     0,     0,
       0,     0,    30,    28,    29,    33,    34,   103,   312,   313,
     103,    63,   230,   231,   204,   103,     0,   101,   102,     0,
       0,     0,   110,     0,     0,   110,     0,     0,     0,     0,
      88,     0,     0,    92,    97,    98,    10,     0,     0,    26,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     239,   305,   308,   311,   303,   306,   309,   304,   307,   310,
     241,   298,   299,   314,     0,   275,    36,    37,    38,    39,
      40,    41,    42,   272,   286,   274,   273,     0,   244,   246,
     248,   257,   262,   265,   269,   270,   271,   295,   201,   240,
     300,   301,   302,   238,   242,   234,   232,   233,     0,    31,
     110,     0,   110,    61,     0,     0,     0,   203,   206,   213,
     221,   220,     0,   228,   229,   238,     0,     0,    65,    66,
     104,   106,   100,     0,   163,    64,   108,     0,     0,    76,
      78,     0,    75,   109,    69,     0,     0,    79,     0,     0,
      68,    67,    86,    90,     0,    89,    94,     0,    93,     0,
      96,   119,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    44,
      44,    44,    44,    44,    44,    44,   201,   197,     0,   243,
       0,   315,   267,   268,   266,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   260,   261,
       0,     0,     0,   200,    44,    32,   119,    62,   119,   227,
       0,   225,   226,   219,     0,     0,   218,   202,   204,   212,
     208,   207,   119,   105,   107,     0,     0,     0,   166,   162,
     173,     0,     0,    72,     0,     0,    77,     0,   110,     0,
       0,     0,    91,    95,    99,     0,   143,   124,     0,     0,
       0,     0,     0,     0,     0,     0,   285,     0,     0,     0,
       0,     0,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   276,     0,     0,   237,     0,
     245,   247,     0,   255,   249,   250,   251,   252,   253,   254,
     258,   259,   263,   264,     0,   196,   201,    60,    59,   223,
     224,   222,   211,   216,   217,   205,    58,   159,   119,   160,
       0,     0,     0,     0,     0,     0,   185,   161,   165,   171,
     168,   175,   177,   178,   176,   174,   179,   169,   163,     0,
      71,     0,    70,    81,    80,     0,     0,     0,     0,     0,
      24,     0,   131,   281,     0,     0,     0,     0,   277,   282,
     283,   284,   278,   280,   291,   292,   293,   294,     0,    46,
       0,    45,     0,     0,     0,     0,    53,    55,     0,   198,
       0,   235,   236,    35,   256,   199,   194,   213,   209,     0,
     214,    25,   180,     0,     0,   189,   192,   190,   191,     0,
       0,   183,     0,     0,   164,   170,   163,   172,     0,     0,
     110,     0,   110,     0,   118,   113,   115,   117,   114,     0,
     145,   122,   123,   120,     0,   129,     0,     0,     0,     0,
       0,    47,    48,    49,    50,    51,     0,     0,     0,    57,
       0,   193,     0,   210,   215,   181,   182,     0,   187,   184,
     167,     0,    74,     0,    83,    85,    84,     0,   112,   147,
     144,   121,     0,     0,     0,   111,   127,   128,     0,   296,
     279,   288,   289,   290,    54,     0,    56,     0,   195,     0,
       0,    73,     0,     0,     0,     0,   146,   149,     0,     0,
     130,   133,   136,   137,   138,   139,   140,   141,   125,   126,
       0,     0,     0,     0,   186,     0,     0,   158,   151,   155,
     157,     0,   153,   156,   154,   142,   148,   134,   135,   132,
     297,    52,   287,   188,   110,   116,   150,   152,    82
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     8,    21,    22,    23,     3,     4,     9,    24,
     285,    25,    43,    44,    45,   125,   326,   420,   126,   127,
     128,   129,   130,   488,   426,   131,   132,    26,    27,    50,
      28,    57,   202,    29,   292,   189,   190,   191,    30,    31,
      32,    33,    34,    75,    35,    58,    59,   178,   179,   180,
     193,   194,   306,   464,   465,   307,   471,   472,   402,   515,
     475,   540,   541,   516,   517,   400,   469,   535,   536,   537,
     561,   562,   186,   287,   288,   377,   378,   379,   456,   289,
     380,   381,   382,   383,   384,   385,   499,   386,   387,   473,
     492,   133,   134,   237,   262,    55,   166,   192,   168,   279,
     438,   280,   362,   440,   363,   275,   169,   170,   171,   270,
     364,   172,   276,   135,   156,   339,   136,   263,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -478
static const yytype_int16 yypact[] =
{
      51,   -55,    74,    47,  -478,  -478,  -478,  -478,   320,   113,
      71,   166,    14,   136,    36,    55,    56,   158,    17,    29,
      90,  -478,   416,  -478,  -478,   136,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,    96,   168,   168,   921,
     104,   104,  -478,  -478,   225,  -478,  -478,   136,  -478,  -478,
      23,  -478,  -478,  -478,  1523,   136,     3,  -478,   136,    78,
     120,  1383,    66,   123,  1383,    66,     4,   -12,   122,    13,
    -478,   128,    31,  -478,  -478,   -19,  -478,    78,   131,  -478,
    -478,   152,   176,   178,   180,   189,   192,   197,   199,   211,
     217,   219,   230,   235,   241,   251,   268,   276,   278,   279,
     280,   282,   283,   284,   285,   289,   610,   163,  1016,  1016,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  1016,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,   301,   286,   287,
    -478,   246,   179,   209,  -478,  -478,  -478,  -478,   921,  -478,
    -478,  -478,  -478,   292,  -478,  -478,  -478,  -478,    21,  -478,
      78,   181,    78,  -478,  1453,   137,   290,  -478,   263,    61,
    -478,  -478,    61,  -478,  -478,  -478,    78,    -8,  -478,  -478,
    -478,  -478,  -478,   303,   338,  -478,  -478,  1416,   181,  -478,
    -478,  1210,  -478,  -478,  -478,  1416,  1247,  -478,   304,   103,
    -478,  -478,  -478,  -478,   288,  -478,  -478,   294,  -478,   -12,
    -478,   347,  -478,   233,   921,   921,   921,   921,   921,   921,
     921,   718,   921,   921,   921,   921,   921,   921,   921,   379,
     379,   379,   379,   379,   379,   379,   921,  -478,   921,  -478,
     317,  -478,  -478,  -478,  -478,    -3,   921,   921,   327,   285,
     921,   921,   921,   921,   921,   921,   921,   921,  -478,  -478,
     921,   921,    32,  -478,   379,  -478,   347,  -478,   347,  -478,
    1490,  -478,  -478,  -478,   318,  1523,  -478,  -478,  1523,  -478,
    -478,  -478,   347,  -478,  -478,   322,    78,   323,   238,  -478,
     291,   297,   326,  -478,   329,    78,  -478,   330,    78,  1383,
     333,  1383,  -478,  -478,  -478,   393,   350,   383,   352,   356,
     357,   358,   359,   374,   375,   376,  -478,   377,   380,   381,
     382,   384,   385,   388,   392,  -478,   826,   921,   921,   921,
     921,   921,   921,    84,   403,  -478,   104,   104,  -478,   391,
     287,  -478,   285,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,   921,  -478,   921,  -478,  -478,  -478,
    -478,  -478,   342,   405,  -478,  -478,  -478,  -478,   347,  -478,
     303,   181,  1223,   181,   303,   406,   445,   238,  -478,   366,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  1523,   404,
    -478,  1523,  -478,  -478,  -478,  1282,  1416,  1317,  1167,   233,
    -478,  1223,   464,  -478,   921,   921,   921,   921,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,   921,  -478,
     411,  -478,   412,   413,   415,   417,   -36,  -478,   418,  -478,
     921,  -478,  -478,  -478,  -478,  -478,   -21,    61,  -478,  1523,
    -478,  -478,  -478,   303,   921,  -478,  -478,  -478,  -478,   292,
     303,  -478,   233,   303,  -478,  -478,  1523,  -478,  1523,   419,
      28,   420,    78,   921,  1167,  -478,  -478,  -478,  -478,   130,
    -478,  -478,  1223,  -478,   469,    48,    95,   421,   422,   425,
     427,  -478,  -478,  -478,  -478,  -478,   921,   453,   429,  -478,
     432,  -478,   431,  -478,  -478,  -478,  -478,   401,  -478,   495,
    -478,   430,  -478,   442,  -478,  -478,  -478,   447,  -478,   448,
    -478,  -478,  1111,   426,   428,  -478,   504,   514,   921,  -478,
    -478,  -478,  -478,  -478,  -478,   444,  -478,   921,  -478,   921,
     303,  -478,  1383,   233,   471,   451,   448,  -478,   457,   457,
    1111,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
     458,   437,   459,   460,  -478,  1350,   461,  -478,  -478,  -478,
    -478,  1063,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,    78,  -478,  -478,  -478,  -478
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -478,  -478,  -478,  -478,  -478,   516,  -478,  -478,  -478,  -478,
    -478,   361,   299,  -478,   -32,  -478,    87,  -478,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
    -478,   171,   331,  -478,  -192,  -478,  -172,   -60,  -478,  -478,
    -478,  -478,  -478,  -478,  -478,   324,   124,  -478,  -478,   364,
     -30,   -63,  -240,  -478,    83,  -478,    70,  -478,  -478,  -478,
    -478,  -478,     8,    26,    33,  -478,  -478,  -478,  -478,    15,
    -478,    -9,  -175,  -478,  -366,  -478,   177,  -478,  -478,  -177,
    -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,   183,
    -478,  -340,  -478,  -232,  -222,  -478,   275,   -47,  -164,  -100,
    -478,   119,   121,  -478,  -478,  -478,  -155,  -478,  -478,  -478,
    -149,  -153,    -6,    25,   -40,  -478,   -48,   367,  -478,   313,
     314,   262,    85,  -478,    79,  -347,  -334,  -478,  -478,  -477,
    -478,   436,   454,   -11,  -478
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      53,   157,   197,   297,   196,    51,   174,   167,   284,   269,
     293,   272,   159,   174,   333,   271,   174,   343,   293,   296,
     290,   177,   457,   290,   296,   447,   357,    56,   358,   185,
     204,   290,   446,   183,    68,    46,    52,   486,   448,    53,
      56,   209,   366,   175,   163,   181,    71,   211,   207,   200,
     175,     5,   354,   175,   447,   198,   199,   563,   466,    56,
     513,   446,    46,    46,   468,   274,     1,   448,   514,    46,
      56,   183,   281,    69,     6,    52,   487,   336,   337,   173,
     503,    37,    38,   183,   563,    72,   173,   210,   273,   173,
     500,   491,    54,    60,   201,    39,   161,   266,    48,   268,
      49,    40,    41,    40,    41,   354,   184,   355,   155,    48,
     434,    49,    63,   376,    61,   269,   174,   272,     7,   205,
     269,   360,   272,    70,   466,   447,   265,    36,   441,    48,
     468,    49,   446,    64,   436,    73,   174,   208,   448,   174,
      56,    40,    41,   174,   184,    39,   282,   174,   174,    77,
      53,    40,    41,   175,    53,   267,   184,   354,    53,   429,
     300,    53,    66,    42,   273,   544,   181,    48,   518,    49,
     519,   160,   542,   175,   162,    67,   175,    53,   545,   176,
     175,   301,   294,    46,   175,   175,    52,   242,   243,   173,
      52,   567,   568,   544,    52,   442,    74,    52,   187,   451,
     542,   195,   376,   244,   461,   338,   545,    78,   509,   173,
      40,    41,   173,    52,   241,   155,   173,    40,    41,   293,
     173,   173,   174,   296,   290,   296,   213,   174,   203,   182,
     174,   167,   290,   182,   206,   394,   182,   212,   308,   395,
     241,   397,    39,    48,   370,    49,    40,    41,    40,    41,
     214,   174,   215,   174,   216,   371,   368,   372,    47,   175,
      42,    40,    41,   217,   175,   392,   218,   175,   495,   256,
     257,   219,    48,   220,    49,   496,   112,   113,   498,   115,
     116,   501,   118,   119,   269,   221,   272,    48,   175,    49,
     175,   222,   290,   223,   290,   173,   431,   432,   158,    39,
     173,   260,   261,   173,   224,    40,    41,   373,   374,   225,
     375,   248,   249,    40,    41,   226,   184,   327,   328,   329,
     330,   331,   332,    10,   173,   227,   173,    11,    12,    13,
     250,   251,   252,   253,   254,   255,    79,    80,    62,    65,
     174,    10,   228,   174,   459,   352,   353,   174,   174,   174,
     229,   356,   230,   231,   232,   554,   233,   234,   235,   236,
      53,   449,    53,   238,   245,   443,   264,   450,   246,   277,
     247,    14,    15,    16,    17,    18,   278,   175,    19,    20,
     175,   184,   299,   296,   175,   175,   175,   449,   305,   325,
     449,   174,   335,   342,   302,   361,    52,   504,    52,   506,
     303,   367,   369,   389,   388,   390,   137,   391,   174,   393,
     174,   396,   164,   173,   165,   398,   173,   399,    40,    41,
     173,   173,   173,   467,   470,   401,    53,   403,   175,   404,
     405,   406,   407,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    48,   175,    49,   175,   123,   408,
     409,   410,   411,   449,   437,   412,   413,   414,   453,   415,
     416,   449,    52,   417,   173,   418,   433,    14,    15,    16,
      17,    18,   555,   240,    19,    20,   430,   497,   439,   455,
     452,   173,   458,   173,   174,   474,   481,   482,   483,   467,
     484,   512,   485,   489,   510,   529,   520,   521,   502,   505,
     522,   449,   523,   525,   526,   527,   528,   174,   530,   531,
     533,   578,   344,   345,   346,   347,   348,   349,   350,   351,
     532,   175,   534,   564,   514,   546,   513,   547,   551,   449,
     565,   444,   571,   570,   572,   573,   575,   543,    76,   557,
     304,   283,   511,   549,   175,   286,   558,   508,   569,   548,
     564,   566,   577,   365,   454,   445,   493,   173,   556,   340,
     494,   341,     0,     0,     0,   543,   559,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   560,    48,   258,    49,
     173,   309,   310,   311,   312,   313,   314,   315,   317,   318,
     319,   320,   321,   322,   323,   324,   259,     0,     0,     0,
       0,     0,     0,     0,     0,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    81,     0,     0,     0,
       0,     0,     0,    82,     0,     0,    83,     0,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,     0,     0,    97,    98,    99,   100,   101,   102,   103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   104,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   106,   239,   107,     0,     0,     0,
      40,    41,     0,   421,   422,   423,   424,   425,   427,   428,
     108,   109,     0,     0,     0,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    48,   121,    49,   122,
     123,   435,     0,     0,   124,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    81,     0,     0,     0,     0,     0,
       0,    82,     0,     0,    83,     0,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,     0,
       0,    97,    98,    99,   100,   101,   102,   103,     0,     0,
       0,   476,   477,   478,   479,     0,     0,     0,     0,     0,
     104,     0,   105,     0,     0,   480,     0,     0,     0,     0,
       0,     0,   106,   316,   107,     0,     0,   490,    40,    41,
       0,     0,     0,     0,     0,     0,     0,     0,   108,   109,
       0,   240,     0,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    48,   121,    49,   122,   123,     0,
     507,     0,   124,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    81,     0,     0,     0,     0,     0,     0,    82,
       0,     0,    83,   524,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,     0,     0,    97,
      98,    99,   100,   101,   102,   103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   550,     0,     0,   104,     0,
     105,     0,     0,     0,   552,     0,   553,     0,     0,     0,
     106,     0,   107,     0,     0,     0,    40,    41,     0,     0,
       0,     0,     0,     0,     0,     0,   108,   109,   419,     0,
       0,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    48,   121,    49,   122,   123,    81,     0,     0,
     124,     0,     0,     0,    82,     0,     0,    83,     0,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,     0,     0,    97,    98,    99,   100,   101,   102,
     103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,     0,   105,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,     0,   107,     0,     0,
       0,    40,    41,     0,     0,     0,     0,     0,     0,     0,
       0,   108,   109,     0,     0,     0,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    48,   121,    49,
     122,   123,    81,     0,     0,   124,     0,     0,     0,    82,
       0,     0,    83,     0,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,     0,     0,    97,
      98,    99,   100,   101,   102,   103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     106,     0,   107,     0,     0,     0,    40,    41,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    48,   121,    49,   122,   123,    81,     0,     0,
       0,   557,     0,     0,    82,   538,   539,    83,   576,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,     0,     0,     0,     0,     0,     0,   559,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   560,    48,
       0,    49,     0,   104,     0,   105,     0,     0,     0,     0,
       0,     0,     0,    81,     0,   444,     0,     0,     0,     0,
      82,    40,    41,    83,     0,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    48,   121,    49,
     122,     0,     0,     0,     0,     0,     0,   188,     0,   104,
       0,   105,     0,     0,     0,     0,     0,     0,     0,    81,
       0,   463,     0,     0,     0,     0,    82,    40,    41,    83,
       0,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,   188,     0,     0,     0,     0,     0,
       0,     0,     0,    48,   121,    49,   122,     0,     0,     0,
       0,     0,     0,     0,   164,   104,   165,   105,     0,   295,
      40,    41,     0,     0,     0,     0,     0,   444,     0,   188,
       0,     0,     0,     0,     0,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    48,     0,    49,     0,
     123,   164,     0,   165,     0,     0,   298,    40,    41,    48,
     121,    49,   122,     0,   188,     0,     0,     0,     0,     0,
       0,     0,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    48,     0,    49,   164,   123,   165,     0,
       0,   460,    40,    41,     0,     0,     0,   188,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    48,     0,
      49,   164,   123,   165,     0,     0,   462,    40,    41,     0,
     188,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    48,   164,    49,   165,   123,     0,   574,
      40,    41,     0,   291,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    48,   164,    49,   165,
     123,     0,     0,    40,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    48,
     164,    49,   165,   123,     0,     0,    40,    41,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    48,     0,    49,     0,   123,   164,   239,   165,
       0,     0,     0,    40,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    48,
       0,    49,     0,   123,   164,   359,   165,     0,     0,     0,
      40,    41,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    48,   164,    49,   165,
     123,     0,     0,    40,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    48,
       0,    49,     0,   123
};

static const yytype_int16 yycheck[] =
{
      11,    41,    65,   195,    64,    11,    54,    54,   183,   164,
     187,   164,    44,    61,   236,   164,    64,   249,   195,   191,
     184,    18,   388,   187,   196,   372,   266,     4,   268,    59,
      17,   195,   372,     5,    17,    10,    11,    73,   372,    50,
       4,    60,   282,    54,    50,    56,    17,    77,    17,    61,
      61,   106,    73,    64,   401,    51,    52,   534,   398,     4,
      12,   401,    37,    38,   398,   165,    15,   401,    20,    44,
       4,     5,   172,    56,     0,    50,   112,    80,    81,    54,
      52,    10,    11,     5,   561,    56,    61,   106,    27,    64,
     456,   112,    78,    57,   106,    74,    73,   160,   106,   162,
     108,    80,    81,    80,    81,    73,    78,    75,   111,   106,
     342,   108,    57,   288,    78,   270,   164,   270,    71,   106,
     275,   270,   275,   106,   464,   472,   158,    14,   368,   106,
     464,   108,   472,    78,   356,   106,   184,   106,   472,   187,
       4,    80,    81,   191,    78,    74,   176,   195,   196,    25,
     161,    80,    81,   164,   165,   161,    78,    73,   169,    75,
      57,   172,   106,    92,    27,   512,   177,   106,    73,   108,
      75,    47,   512,   184,    50,    17,   187,   188,   512,    55,
     191,    78,   188,   158,   195,   196,   161,   108,   109,   164,
     165,   538,   539,   540,   169,   370,   106,   172,    78,   374,
     540,    78,   377,   124,   396,   245,   540,   111,    78,   184,
      80,    81,   187,   188,    77,   111,   191,    80,    81,   396,
     195,   196,   270,   395,   388,   397,    74,   275,   106,    58,
     278,   278,   396,    62,   106,   298,    65,   106,   213,   299,
      77,   301,    74,   106,     6,   108,    80,    81,    80,    81,
      74,   299,    74,   301,    74,    17,   286,    19,    92,   270,
      92,    80,    81,    74,   275,   295,    74,   278,   443,    90,
      91,    74,   106,    74,   108,   450,    97,    98,   453,   100,
     101,   458,   103,   104,   439,    74,   439,   106,   299,   108,
     301,    74,   456,    74,   458,   270,   336,   337,    73,    74,
     275,    92,    93,   278,    74,    80,    81,    69,    70,    74,
      72,    65,    66,    80,    81,    74,    78,   230,   231,   232,
     233,   234,   235,     3,   299,    74,   301,     7,     8,     9,
      84,    85,    86,    87,    88,    89,    37,    38,    14,    15,
     388,     3,    74,   391,   391,   260,   261,   395,   396,   397,
      74,   264,    74,    74,    74,   530,    74,    74,    74,    74,
     371,   372,   373,    74,    63,   371,    74,   373,    82,    79,
      83,    51,    52,    53,    54,    55,   113,   388,    58,    59,
     391,    78,    78,   555,   395,   396,   397,   398,    41,    10,
     401,   439,    75,    66,   106,    77,   371,   460,   373,   462,
     106,    79,    79,   106,   113,    79,    39,    78,   456,    79,
     458,    78,    74,   388,    76,    22,   391,    67,    80,    81,
     395,   396,   397,   398,   399,    42,   437,    75,   439,    73,
      73,    73,    73,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   456,   108,   458,   110,    75,
      75,    75,    75,   464,   112,    75,    75,    75,    13,    75,
      75,   472,   437,    75,   439,    73,    75,    51,    52,    53,
      54,    55,   532,   106,    58,    59,    73,   452,    73,   113,
      74,   456,    78,   458,   532,    21,    75,    75,    75,   464,
      75,    22,    75,    75,   469,    94,    75,    75,    79,    79,
      75,   512,    75,    50,    75,    73,    75,   555,    13,    79,
      63,   574,   250,   251,   252,   253,   254,   255,   256,   257,
      78,   532,    74,   534,    20,    99,    12,    99,    84,   540,
      79,    74,    95,    75,    75,    75,    75,   512,    22,    68,
     209,   177,   472,   517,   555,   184,    75,   464,   540,   516,
     561,   536,   561,   278,   377,   372,   437,   532,   533,   246,
     439,   247,    -1,    -1,    -1,   540,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   142,   108,
     555,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    16,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    -1,    -1,    26,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    -1,   326,   327,   328,   329,   330,   331,   332,
      90,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   354,    -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    -1,    -1,    26,    -1,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    -1,    -1,
      -1,   404,   405,   406,   407,    -1,    -1,    -1,    -1,    -1,
      62,    -1,    64,    -1,    -1,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    74,    75,    76,    -1,    -1,   430,    80,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      -1,   444,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     463,    -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    16,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      -1,    -1,    26,   486,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   518,    -1,    -1,    62,    -1,
      64,    -1,    -1,    -1,   527,    -1,   529,    -1,    -1,    -1,
      74,    -1,    76,    -1,    -1,    -1,    80,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    16,    -1,    -1,
     114,    -1,    -1,    -1,    23,    -1,    -1,    26,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    76,    -1,    -1,
      -1,    80,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    16,    -1,    -1,   114,    -1,    -1,    -1,    23,
      -1,    -1,    26,    -1,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    -1,    76,    -1,    -1,    -1,    80,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    16,    -1,    -1,
      -1,    68,    -1,    -1,    23,    24,    25,    26,    75,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
      -1,   108,    -1,    62,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    16,    -1,    74,    -1,    -1,    -1,    -1,
      23,    80,    81,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   106,   107,   108,
     109,    -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,    62,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,
      -1,    74,    -1,    -1,    -1,    -1,    23,    80,    81,    26,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   106,   107,   108,   109,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    74,    62,    76,    64,    -1,    79,
      80,    81,    -1,    -1,    -1,    -1,    -1,    74,    -1,    17,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,    -1,   108,    -1,
     110,    74,    -1,    76,    -1,    -1,    79,    80,    81,   106,
     107,   108,   109,    -1,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,    -1,   108,    74,   110,    76,    -1,
      -1,    79,    80,    81,    -1,    -1,    -1,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,    -1,
     108,    74,   110,    76,    -1,    -1,    79,    80,    81,    -1,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,    74,   108,    76,   110,    -1,    79,
      80,    81,    -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,    74,   108,    76,
     110,    -1,    -1,    80,    81,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
      74,   108,    76,   110,    -1,    -1,    80,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,    -1,   108,    -1,   110,    74,    75,    76,
      -1,    -1,    -1,    80,    81,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
      -1,   108,    -1,   110,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,    74,   108,    76,
     110,    -1,    -1,    80,    81,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
      -1,   108,    -1,   110
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    15,   116,   121,   122,   106,     0,    71,   117,   123,
       3,     7,     8,     9,    51,    52,    53,    54,    55,    58,
      59,   118,   119,   120,   124,   126,   142,   143,   145,   148,
     153,   154,   155,   156,   157,   159,    14,    10,    11,    74,
      80,    81,    92,   127,   128,   129,   228,    92,   106,   108,
     144,   227,   228,   248,    78,   210,     4,   146,   160,   161,
      57,    78,   160,    57,    78,   160,   106,    17,    17,    56,
     106,    17,    56,   106,   106,   158,   120,   161,   111,   127,
     127,    16,    23,    26,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    43,    44,    45,
      46,    47,    48,    49,    62,    64,    74,    76,    90,    91,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   107,   109,   110,   114,   130,   133,   134,   135,   136,
     137,   140,   141,   206,   207,   228,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   111,   229,   229,    73,   129,
     161,    73,   161,   227,    74,    76,   211,   212,   213,   221,
     222,   223,   226,   228,   231,   248,   161,    18,   162,   163,
     164,   248,   146,     5,    78,   165,   187,    78,    17,   150,
     151,   152,   212,   165,   166,    78,   152,   166,    51,    52,
      61,   106,   147,   106,    17,   106,   106,    17,   106,    60,
     106,   165,   106,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,   208,    74,    75,
     232,    77,   239,   239,   239,    63,    82,    83,    65,    66,
      84,    85,    86,    87,    88,    89,    90,    91,   246,   247,
      92,    93,   209,   232,    74,   129,   166,   227,   166,   221,
     224,   225,   226,    27,   214,   220,   227,    79,   113,   214,
     216,   214,   165,   164,   187,   125,   126,   188,   189,   194,
     213,    17,   149,   194,   227,    79,   151,   149,    79,    78,
      57,    78,   106,   106,   147,    41,   167,   170,   228,   232,
     232,   232,   232,   232,   232,   232,    75,   232,   232,   232,
     232,   232,   232,   232,   232,    10,   131,   131,   131,   131,
     131,   131,   131,   209,   232,    75,    80,    81,   229,   230,
     234,   235,    66,   208,   236,   236,   236,   236,   236,   236,
     236,   236,   237,   237,    73,    75,   131,   167,   167,    75,
     225,    77,   217,   219,   225,   211,   167,    79,   165,    79,
       6,    17,    19,    69,    70,    72,   187,   190,   191,   192,
     195,   196,   197,   198,   199,   200,   202,   203,   113,   106,
      79,    78,   165,    79,   166,   152,    78,   152,    22,    67,
     180,    42,   173,    75,    73,    73,    73,    73,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    73,    92,
     132,   232,   232,   232,   232,   232,   139,   232,   232,    75,
      73,   229,   229,    75,   208,   232,   209,   112,   215,    73,
     218,   167,   187,   227,    74,   204,   206,   240,   241,   248,
     227,   187,    74,    13,   191,   113,   193,   189,    78,   212,
      79,   149,    79,    74,   168,   169,   206,   228,   241,   181,
     228,   171,   172,   204,    21,   175,   232,   232,   232,   232,
     232,    75,    75,    75,    75,    75,    73,   112,   138,    75,
     232,   112,   205,   216,   217,   187,   187,   228,   187,   201,
     189,   194,    79,    52,   166,    79,   166,   232,   169,    78,
     228,   171,    22,    12,    20,   174,   178,   179,    73,    75,
      75,    75,    75,    75,   232,    50,    75,    73,    75,    94,
      13,    79,    78,    63,    74,   182,   183,   184,    24,    25,
     176,   177,   206,   228,   240,   241,    99,    99,   179,   178,
     232,    84,   232,   232,   187,   152,   228,    68,    75,    95,
     105,   185,   186,   244,   248,    79,   184,   240,   240,   177,
      75,    95,    75,    75,    79,    75,    75,   186,   166
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 95: /* "\"string literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2133 "sparql_parser.c"
	break;
      case 96: /* "\"double literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2145 "sparql_parser.c"
	break;
      case 97: /* "\"double positive literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2157 "sparql_parser.c"
	break;
      case 98: /* "\"double negative literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2169 "sparql_parser.c"
	break;
      case 99: /* "\"integer literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2181 "sparql_parser.c"
	break;
      case 100: /* "\"integer positive literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2193 "sparql_parser.c"
	break;
      case 101: /* "\"integer negative literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2205 "sparql_parser.c"
	break;
      case 102: /* "\"decimal literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2217 "sparql_parser.c"
	break;
      case 103: /* "\"decimal positive literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2229 "sparql_parser.c"
	break;
      case 104: /* "\"decimal negative literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2241 "sparql_parser.c"
	break;
      case 105: /* "\"boolean literal\"" */

/* Line 1000 of yacc.c  */
#line 299 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2253 "sparql_parser.c"
	break;
      case 106: /* "\"URI literal\"" */

/* Line 1000 of yacc.c  */
#line 310 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2265 "sparql_parser.c"
	break;
      case 107: /* "\"URI literal (\"" */

/* Line 1000 of yacc.c  */
#line 310 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2277 "sparql_parser.c"
	break;
      case 108: /* "\"QName literal\"" */

/* Line 1000 of yacc.c  */
#line 316 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2289 "sparql_parser.c"
	break;
      case 109: /* "\"QName literal (\"" */

/* Line 1000 of yacc.c  */
#line 316 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2301 "sparql_parser.c"
	break;
      case 110: /* "\"blank node literal\"" */

/* Line 1000 of yacc.c  */
#line 316 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2313 "sparql_parser.c"
	break;
      case 111: /* "\"identifier\"" */

/* Line 1000 of yacc.c  */
#line 316 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2325 "sparql_parser.c"
	break;
      case 124: /* "SelectQuery" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2337 "sparql_parser.c"
	break;
      case 125: /* "SubSelect" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2349 "sparql_parser.c"
	break;
      case 126: /* "SelectClause" */

/* Line 1000 of yacc.c  */
#line 419 "./sparql_parser.y"
	{
  if((yyvaluep->projection))
    rasqal_free_projection((yyvaluep->projection));
};

/* Line 1000 of yacc.c  */
#line 2361 "sparql_parser.c"
	break;
      case 127: /* "SelectExpressionList" */

/* Line 1000 of yacc.c  */
#line 419 "./sparql_parser.y"
	{
  if((yyvaluep->projection))
    rasqal_free_projection((yyvaluep->projection));
};

/* Line 1000 of yacc.c  */
#line 2373 "sparql_parser.c"
	break;
      case 128: /* "SelectExpressionListTail" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2385 "sparql_parser.c"
	break;
      case 129: /* "SelectTerm" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 2397 "sparql_parser.c"
	break;
      case 130: /* "AggregateExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2409 "sparql_parser.c"
	break;
      case 132: /* "ExpressionOrStar" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2421 "sparql_parser.c"
	break;
      case 133: /* "CountAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2433 "sparql_parser.c"
	break;
      case 134: /* "SumAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2445 "sparql_parser.c"
	break;
      case 135: /* "AvgAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2457 "sparql_parser.c"
	break;
      case 136: /* "MinAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2469 "sparql_parser.c"
	break;
      case 137: /* "MaxAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2481 "sparql_parser.c"
	break;
      case 138: /* "SeparatorOpt" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2493 "sparql_parser.c"
	break;
      case 140: /* "GroupConcatAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2505 "sparql_parser.c"
	break;
      case 141: /* "SampleAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2517 "sparql_parser.c"
	break;
      case 142: /* "ConstructQuery" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2529 "sparql_parser.c"
	break;
      case 143: /* "DescribeQuery" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2541 "sparql_parser.c"
	break;
      case 144: /* "VarOrIRIrefList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2553 "sparql_parser.c"
	break;
      case 146: /* "DatasetClause" */

/* Line 1000 of yacc.c  */
#line 401 "./sparql_parser.y"
	{
  if((yyvaluep->data_graph))
    rasqal_free_data_graph((yyvaluep->data_graph));
};

/* Line 1000 of yacc.c  */
#line 2565 "sparql_parser.c"
	break;
      case 147: /* "GraphRef" */

/* Line 1000 of yacc.c  */
#line 310 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2577 "sparql_parser.c"
	break;
      case 149: /* "GraphTriples" */

/* Line 1000 of yacc.c  */
#line 339 "./sparql_parser.y"
	{
  if((yyvaluep->update))
    rasqal_free_update_operation((yyvaluep->update));
};

/* Line 1000 of yacc.c  */
#line 2589 "sparql_parser.c"
	break;
      case 150: /* "GraphTemplate" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2601 "sparql_parser.c"
	break;
      case 151: /* "ModifyTemplate" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2613 "sparql_parser.c"
	break;
      case 152: /* "ModifyTemplateList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2625 "sparql_parser.c"
	break;
      case 158: /* "IriRefList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2637 "sparql_parser.c"
	break;
      case 160: /* "DatasetClauseList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2649 "sparql_parser.c"
	break;
      case 161: /* "DatasetClauseListOpt" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2661 "sparql_parser.c"
	break;
      case 162: /* "DefaultGraphClause" */

/* Line 1000 of yacc.c  */
#line 401 "./sparql_parser.y"
	{
  if((yyvaluep->data_graph))
    rasqal_free_data_graph((yyvaluep->data_graph));
};

/* Line 1000 of yacc.c  */
#line 2673 "sparql_parser.c"
	break;
      case 163: /* "NamedGraphClause" */

/* Line 1000 of yacc.c  */
#line 401 "./sparql_parser.y"
	{
  if((yyvaluep->data_graph))
    rasqal_free_data_graph((yyvaluep->data_graph));
};

/* Line 1000 of yacc.c  */
#line 2685 "sparql_parser.c"
	break;
      case 164: /* "SourceSelector" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2697 "sparql_parser.c"
	break;
      case 167: /* "SolutionModifier" */

/* Line 1000 of yacc.c  */
#line 413 "./sparql_parser.y"
	{
  if((yyvaluep->modifier))
    rasqal_free_solution_modifier((yyvaluep->modifier));
};

/* Line 1000 of yacc.c  */
#line 2709 "sparql_parser.c"
	break;
      case 168: /* "GroupConditionList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2721 "sparql_parser.c"
	break;
      case 169: /* "GroupCondition" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2733 "sparql_parser.c"
	break;
      case 170: /* "GroupClauseOpt" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2745 "sparql_parser.c"
	break;
      case 171: /* "HavingCondition" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2757 "sparql_parser.c"
	break;
      case 172: /* "HavingConditionList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2769 "sparql_parser.c"
	break;
      case 173: /* "HavingClauseOpt" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2781 "sparql_parser.c"
	break;
      case 175: /* "OrderClauseOpt" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2793 "sparql_parser.c"
	break;
      case 176: /* "OrderConditionList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2805 "sparql_parser.c"
	break;
      case 177: /* "OrderCondition" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2817 "sparql_parser.c"
	break;
      case 180: /* "BindingsClauseOpt" */

/* Line 1000 of yacc.c  */
#line 426 "./sparql_parser.y"
	{
  if((yyvaluep->bindings))
    rasqal_free_bindings((yyvaluep->bindings));
};

/* Line 1000 of yacc.c  */
#line 2829 "sparql_parser.c"
	break;
      case 181: /* "VarList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2841 "sparql_parser.c"
	break;
      case 182: /* "BindingsRowListOpt" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2853 "sparql_parser.c"
	break;
      case 183: /* "BindingsRowList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2865 "sparql_parser.c"
	break;
      case 184: /* "BindingsRow" */

/* Line 1000 of yacc.c  */
#line 407 "./sparql_parser.y"
	{
  if((yyvaluep->row))
    rasqal_free_row((yyvaluep->row));
};

/* Line 1000 of yacc.c  */
#line 2877 "sparql_parser.c"
	break;
      case 185: /* "BindingValueList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2889 "sparql_parser.c"
	break;
      case 186: /* "BindingValue" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2901 "sparql_parser.c"
	break;
      case 187: /* "GroupGraphPattern" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2913 "sparql_parser.c"
	break;
      case 188: /* "GroupGraphPatternSub" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2925 "sparql_parser.c"
	break;
      case 189: /* "TriplesBlockOpt" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2937 "sparql_parser.c"
	break;
      case 190: /* "GraphPatternListOpt" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2949 "sparql_parser.c"
	break;
      case 191: /* "GraphPatternList" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2961 "sparql_parser.c"
	break;
      case 192: /* "GraphPatternListFilter" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2973 "sparql_parser.c"
	break;
      case 194: /* "TriplesBlock" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2985 "sparql_parser.c"
	break;
      case 195: /* "GraphPatternNotTriples" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2997 "sparql_parser.c"
	break;
      case 196: /* "OptionalGraphPattern" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3009 "sparql_parser.c"
	break;
      case 197: /* "GraphGraphPattern" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3021 "sparql_parser.c"
	break;
      case 198: /* "ServiceGraphPattern" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3033 "sparql_parser.c"
	break;
      case 199: /* "MinusGraphPattern" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3045 "sparql_parser.c"
	break;
      case 200: /* "GroupOrUnionGraphPattern" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3057 "sparql_parser.c"
	break;
      case 201: /* "GroupOrUnionGraphPatternList" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3069 "sparql_parser.c"
	break;
      case 202: /* "LetGraphPattern" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3081 "sparql_parser.c"
	break;
      case 203: /* "Filter" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3093 "sparql_parser.c"
	break;
      case 204: /* "Constraint" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3105 "sparql_parser.c"
	break;
      case 205: /* "ParamsOpt" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3117 "sparql_parser.c"
	break;
      case 206: /* "FunctionCall" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3129 "sparql_parser.c"
	break;
      case 207: /* "CoalesceExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3141 "sparql_parser.c"
	break;
      case 208: /* "ArgList" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3153 "sparql_parser.c"
	break;
      case 209: /* "ArgListNoBraces" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3165 "sparql_parser.c"
	break;
      case 210: /* "ConstructTemplate" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3177 "sparql_parser.c"
	break;
      case 211: /* "ConstructTriplesOpt" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3189 "sparql_parser.c"
	break;
      case 212: /* "ConstructTriples" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3201 "sparql_parser.c"
	break;
      case 213: /* "TriplesSameSubject" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3213 "sparql_parser.c"
	break;
      case 214: /* "PropertyListNotEmpty" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3225 "sparql_parser.c"
	break;
      case 215: /* "PropertyListTailOpt" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3237 "sparql_parser.c"
	break;
      case 216: /* "PropertyList" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3249 "sparql_parser.c"
	break;
      case 217: /* "ObjectList" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3261 "sparql_parser.c"
	break;
      case 218: /* "ObjectTail" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3273 "sparql_parser.c"
	break;
      case 219: /* "Object" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3285 "sparql_parser.c"
	break;
      case 220: /* "Verb" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3297 "sparql_parser.c"
	break;
      case 221: /* "TriplesNode" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3309 "sparql_parser.c"
	break;
      case 222: /* "BlankNodePropertyList" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3321 "sparql_parser.c"
	break;
      case 223: /* "Collection" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3333 "sparql_parser.c"
	break;
      case 224: /* "GraphNodeListNotEmpty" */

/* Line 1000 of yacc.c  */
#line 322 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3345 "sparql_parser.c"
	break;
      case 225: /* "GraphNode" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3357 "sparql_parser.c"
	break;
      case 226: /* "VarOrTerm" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3369 "sparql_parser.c"
	break;
      case 227: /* "VarOrIRIref" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3381 "sparql_parser.c"
	break;
      case 228: /* "Var" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3393 "sparql_parser.c"
	break;
      case 229: /* "VarName" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3405 "sparql_parser.c"
	break;
      case 231: /* "GraphTerm" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3417 "sparql_parser.c"
	break;
      case 232: /* "Expression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3429 "sparql_parser.c"
	break;
      case 233: /* "ConditionalOrExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3441 "sparql_parser.c"
	break;
      case 234: /* "ConditionalAndExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3453 "sparql_parser.c"
	break;
      case 235: /* "RelationalExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3465 "sparql_parser.c"
	break;
      case 236: /* "AdditiveExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3477 "sparql_parser.c"
	break;
      case 237: /* "MultiplicativeExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3489 "sparql_parser.c"
	break;
      case 238: /* "UnaryExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3501 "sparql_parser.c"
	break;
      case 239: /* "PrimaryExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3513 "sparql_parser.c"
	break;
      case 240: /* "BrackettedExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3525 "sparql_parser.c"
	break;
      case 241: /* "BuiltInCall" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3537 "sparql_parser.c"
	break;
      case 242: /* "RegexExpression" */

/* Line 1000 of yacc.c  */
#line 368 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3549 "sparql_parser.c"
	break;
      case 243: /* "IRIrefBrace" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3561 "sparql_parser.c"
	break;
      case 244: /* "NumericLiteral" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3573 "sparql_parser.c"
	break;
      case 245: /* "NumericLiteralUnsigned" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3585 "sparql_parser.c"
	break;
      case 246: /* "NumericLiteralPositive" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3597 "sparql_parser.c"
	break;
      case 247: /* "NumericLiteralNegative" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3609 "sparql_parser.c"
	break;
      case 248: /* "IRIref" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3621 "sparql_parser.c"
	break;
      case 249: /* "BlankNode" */

/* Line 1000 of yacc.c  */
#line 384 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3633 "sparql_parser.c"
	break;

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 442 "./sparql_parser.y"
    {
}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 448 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(sparql->experimental)
    ((rasqal_query*)rq)->explain = 1;
  else
    sparql_syntax_error((rasqal_query*)rq, 
                        "EXPLAIN can only used with LAQRS");
}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 459 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 467 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->selects = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_SELECT;
}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 472 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->constructs = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_CONSTRUCT;
}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 477 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->describes = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_DESCRIBE;
}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 482 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_ASK;
}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 495 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_DELETE;
}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 499 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_INSERT;
}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 503 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 507 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 511 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 515 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 519 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 527 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 535 "./sparql_parser.y"
    {
  rasqal_query_set_base_uri((rasqal_query*)rq, (yyvsp[(2) - (2)].uri));
}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 539 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 547 "./sparql_parser.y"
    {
  raptor_sequence *seq = ((rasqal_query*)rq)->prefixes;
  unsigned const char* prefix_string = (yyvsp[(3) - (4)].name);
  size_t l = 0;

  if(prefix_string)
    l=strlen((const char*)prefix_string);
  
  if(raptor_namespaces_find_namespace(((rasqal_query*)rq)->namespaces,
                                      prefix_string, l)) {
    /* A prefix may be defined only once */
    sparql_syntax_warning(((rasqal_query*)rq), 
                          "PREFIX %s can be defined only once.",
                          prefix_string ? (const char*)prefix_string : ":");
    RASQAL_FREE(cstring, prefix_string);
    raptor_free_uri((yyvsp[(4) - (4)].uri));
  } else {
    rasqal_prefix *p;
    p = rasqal_new_prefix(((rasqal_query*)rq)->world, prefix_string, (yyvsp[(4) - (4)].uri));
    if(!p)
      YYERROR_MSG("PrefixDeclOpt: failed to create new prefix");
    if(raptor_sequence_push(seq, p))
      YYERROR_MSG("PrefixDeclOpt: cannot push prefix to seq");
    if(rasqal_query_declare_prefix(((rasqal_query*)rq), p)) {
      YYERROR_MSG("PrefixDeclOpt: cannot declare prefix");
    }
  }
}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 576 "./sparql_parser.y"
    {
  /* nothing to do, rq->prefixes already initialised */
}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 584 "./sparql_parser.y"
    {
  /* FIXME - this peeks inside rasqal_projection */
  (yyval.seq) = (yyvsp[(1) - (5)].projection)->variables; (yyvsp[(1) - (5)].projection)->variables = NULL;
  if((yyvsp[(1) - (5)].projection)->wildcard)
    ((rasqal_query*)rq)->wildcard = 1;
  ((rasqal_query*)rq)->distinct = (yyvsp[(1) - (5)].projection)->distinct;
  rasqal_free_projection((yyvsp[(1) - (5)].projection));
  
  if((yyvsp[(2) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (5)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (5)].graph_pattern);

  if((yyvsp[(4) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(4) - (5)].modifier);
  
  if((yyvsp[(5) - (5)].bindings))
    ((rasqal_query*)rq)->bindings = (yyvsp[(5) - (5)].bindings);
  
}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 608 "./sparql_parser.y"
    {
  if((yyvsp[(1) - (3)].projection) && (yyvsp[(2) - (3)].graph_pattern) && (yyvsp[(3) - (3)].modifier))
    (yyval.graph_pattern) = rasqal_new_select_graph_pattern((rasqal_query*)rq,
                                         (yyvsp[(1) - (3)].projection), (yyvsp[(2) - (3)].graph_pattern), (yyvsp[(3) - (3)].modifier));
  else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 619 "./sparql_parser.y"
    {
  (yyval.projection) = (yyvsp[(3) - (3)].projection);
  (yyval.projection)->distinct = 1;
}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 624 "./sparql_parser.y"
    {
  (yyval.projection) = (yyvsp[(3) - (3)].projection);
  (yyval.projection)->distinct = 2;
}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 629 "./sparql_parser.y"
    {
  (yyval.projection) = (yyvsp[(2) - (2)].projection);
}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 639 "./sparql_parser.y"
    {
  (yyval.projection) = rasqal_new_projection((rasqal_query*)rq, (yyvsp[(1) - (1)].seq), 0, 0);
}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 643 "./sparql_parser.y"
    {
  (yyval.projection) = rasqal_new_projection((rasqal_query*)rq, NULL, /* wildcard */ 1, 0);
}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 653 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 1: sequence push failed");
  }
}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 662 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 2: sequence push failed");
  }
}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 671 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_variable,
                           (raptor_data_print_handler)rasqal_variable_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_variable,
                           (raptor_sequence_print_handler*)rasqal_variable_print);
#endif
  if(!(yyval.seq))
    YYERROR_MSG("SelectExpressionListTail 3: failed to create sequence");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 3: sequence push failed");
  }
}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 694 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(1) - (1)].variable);
}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 698 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.variable) = NULL;
  if(!sparql->sparql11_query)
    sparql_syntax_error((rasqal_query*)rq,
                        "SELECT ( expression ) AS Variable cannot be used with SPARQL 1.0");
  else {
    if(rasqal_expression_mentions_variable((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].variable))) {
      sparql_query_error_full((rasqal_query*)rq, 
                              "Expression in SELECT ( expression ) AS %s contains the variable name '%s'",
                              (yyvsp[(4) - (5)].variable)->name, (yyvsp[(4) - (5)].variable)->name);
    } else {
      (yyval.variable) = (yyvsp[(4) - (5)].variable);
      (yyval.variable)->expression = (yyvsp[(2) - (5)].expr);
    }

  }
}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 738 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 742 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 746 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 750 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 754 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 758 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 762 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 769 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_query)
    sparql_syntax_error((rasqal_query*)rq,
                        "functions with DISTINCT cannot be used with SPARQL 1.0");
  (yyval.uinteger) = RASQAL_EXPR_FLAG_DISTINCT;
}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 779 "./sparql_parser.y"
    {
  (yyval.uinteger) = 0;
}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 786 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 790 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_VARSTAR);
}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 798 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "COUNT() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_COUNT, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("CountAggregateExpression: cannot create expr");
  }
}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 818 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SUM() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_SUM, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("SumAggregateExpression: cannot create expr");
  }
}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 838 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "AVG() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_AVG, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("AvgAggregateExpression: cannot create expr");
  }
}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 858 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MIN() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_MIN, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("MinAggregateExpression: cannot create expr");
  }
}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 878 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MAX() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_MAX, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("MaxAggregateExpression: cannot create expr");
  }
}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 898 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(4) - (4)].literal);
}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 902 "./sparql_parser.y"
    {
  (yyval.literal) = NULL;
}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 912 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].expr))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("ExpressionList 1: sequence push failed");
  }
}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 921 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq))
    YYERROR_MSG("ExpressionList 2: failed to create sequence");

  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("ExpressionList 2: sequence push failed");
  }
}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 942 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "GROUP_CONCAT() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    int flags = 0;
    
    if((yyvsp[(3) - (6)].uinteger))
      flags |= RASQAL_EXPR_FLAG_DISTINCT;

    (yyval.expr) = rasqal_new_group_concat_expression(((rasqal_query*)rq)->world,
                                            flags /* flags */,
                                            (yyvsp[(4) - (6)].seq) /* args */,
                                            (yyvsp[(5) - (6)].literal) /* separator */);
    if(!(yyval.expr))
      YYERROR_MSG("GroupConcatAggregateExpression: cannot create expr");
  }
}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 969 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SAMPLE() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_SAMPLE, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("SampleAggregateExpression: cannot create expr");
  }
}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 991 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (5)].seq);

  if((yyvsp[(3) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(3) - (5)].seq));
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);

  if((yyvsp[(5) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(5) - (5)].modifier);
}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 1007 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (5)].seq);

  if((yyvsp[(3) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(3) - (5)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);

  if((yyvsp[(5) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(5) - (5)].modifier);
}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 1020 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;

  if((yyvsp[(3) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(3) - (5)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);

  if((yyvsp[(5) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(5) - (5)].modifier);
}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 1036 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 1: sequence push failed");
  }
}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 1045 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 2: sequence push failed");
  }
}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 1054 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_literal,
                           (raptor_data_print_handler)rasqal_literal_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_literal,
                           (raptor_sequence_print_handler*)rasqal_literal_print);
#endif
  if(!(yyval.seq))
    YYERROR_MSG("VarOrIRIrefList 3: cannot create seq");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 3: sequence push failed");
  }
}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 1076 "./sparql_parser.y"
    {
  if((yyvsp[(2) - (3)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (3)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1087 "./sparql_parser.y"
    {
  (yyval.data_graph) = (yyvsp[(2) - (2)].data_graph);
}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 1091 "./sparql_parser.y"
    {
  (yyval.data_graph) = (yyvsp[(2) - (2)].data_graph);
}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1099 "./sparql_parser.y"
    {
  (yyval.uri) = (yyvsp[(1) - (1)].uri);
}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1103 "./sparql_parser.y"
    {
  (yyval.uri) = NULL;
}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1111 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE cannot be used with SPARQL 1.0");

  /* LAQRS: experimental syntax */
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "DELETE FROM <uri> ... WHERE ... is deprecated LAQRS syntax.");

  if((yyvsp[(2) - (3)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (3)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1129 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE cannot be used with SPARQL 1.0");

  /* SPARQL 1.1 (Draft) update:
   * deleting via template + query - not inline atomic triples 
   */

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       NULL /* insert templates */,
                                       (yyvsp[(3) - (5)].seq) /* delete templates */,
                                       (yyvsp[(5) - (5)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("DeleteQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DeleteQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1158 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE DATA cannot be used with SPARQL 1.0");

  /* SPARQL 1.1 (Draft) update:
   * deleting inline triples - not inserting from graph URIs 
   */
  (yyvsp[(4) - (5)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(4) - (5)].update)->delete_templates = (yyvsp[(4) - (5)].update)->insert_templates; (yyvsp[(4) - (5)].update)->insert_templates = NULL;
  (yyvsp[(4) - (5)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;
  
  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(4) - (5)].update));
}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1180 "./sparql_parser.y"
    {
  (yyval.update) = NULL;
 
  if((yyvsp[(1) - (1)].formula)) {
    (yyval.update) = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UNKNOWN,
                                     NULL /* graph_uri */,
                                     NULL /* document_uri */,
                                     (yyvsp[(1) - (1)].formula)->triples /* insert templates */, 
                                     NULL /* delete templates */,
                                     NULL /* where */,
                                     0 /* flags */);
    (yyvsp[(1) - (1)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (1)].formula));
  }
}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1196 "./sparql_parser.y"
    {
  (yyval.update) = NULL;

  if((yyvsp[(4) - (5)].formula)) {
    (yyval.update) = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UNKNOWN,
                                     (yyvsp[(2) - (5)].uri) /* graph uri */,
                                     NULL /* document uri */,
                                     (yyvsp[(4) - (5)].formula)->triples /* insert templates */,
                                     NULL /* delete templates */,
                                     NULL /* where */,
                                     0 /* flags */);
    (yyvsp[(4) - (5)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(4) - (5)].formula));
  }
}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1216 "./sparql_parser.y"
    {
  if((yyvsp[(4) - (5)].seq)) {
    (yyval.graph_pattern) = rasqal_new_basic_graph_pattern_from_triples((rasqal_query*)rq, (yyvsp[(4) - (5)].seq));
    if(!(yyval.graph_pattern))
      YYERROR_MSG("GraphGraphPattern: cannot create graph pattern");
    else
      rasqal_graph_pattern_set_origin((yyval.graph_pattern), (yyvsp[(2) - (5)].literal));
  }
}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1231 "./sparql_parser.y"
    {
  if((yyvsp[(1) - (1)].seq))
    (yyval.graph_pattern) = rasqal_new_basic_graph_pattern_from_triples((rasqal_query*)rq, (yyvsp[(1) - (1)].seq));
  else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1238 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1246 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);

  if((yyvsp[(2) - (2)].graph_pattern)) {
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].graph_pattern))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ModifyTemplateList 1: sequence push failed");
    }
  }

}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1259 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                           (raptor_data_print_handler)rasqal_graph_pattern_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern,
                           (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
#endif
  if(!(yyval.seq))
    YYERROR_MSG("ModifyTemplateList 2: cannot create sequence");
  if((yyval.seq)) {
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].graph_pattern))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ModifyTemplateList 2: sequence push failed");
    }
  }
}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1283 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql  = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT cannot be used with SPARQL 1.0");

  /* LAQRS: experimental syntax */
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "INSERT FROM <uri> ... WHERE ... is deprecated LAQRS syntax.");

  if((yyvsp[(2) - (3)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (3)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1301 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT cannot be used with SPARQL 1.0");

  /* inserting via template + query - not inline atomic triples */

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       (yyvsp[(3) - (5)].seq) /* insert templates */,
                                       NULL /* delete templates */,
                                       (yyvsp[(5) - (5)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("InsertQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("InsertQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1328 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT DATA cannot be used with SPARQL 1.0");

  /* inserting inline atomic triples (no variables) - not via template */
  (yyvsp[(4) - (5)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(4) - (5)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;

  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(4) - (5)].update));
}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1349 "./sparql_parser.y"
    {
  rasqal_update_operation* update;

  /* after this $2, $5, $9 and $12 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       (yyvsp[(2) - (11)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       (yyvsp[(9) - (11)].seq) /* insert templates */,
                                       (yyvsp[(5) - (11)].seq) /* delete templates */,
                                       (yyvsp[(11) - (11)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 1: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 1: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1370 "./sparql_parser.y"
    {
  rasqal_update_operation* update;

  /* after this $2, $5 and $8 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       (yyvsp[(2) - (7)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL /* insert templates */,
                                       (yyvsp[(5) - (7)].seq) /* delete templates */,
                                       (yyvsp[(7) - (7)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 2: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 2: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1391 "./sparql_parser.y"
    {
  rasqal_update_operation* update;

  /* after this $2, $5 and $8 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       (yyvsp[(2) - (7)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       (yyvsp[(5) - (7)].seq) /* insert templates */,
                                       NULL /* delete templates */,
                                       (yyvsp[(7) - (7)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 3: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 3: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1411 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT DATA cannot be used with SPARQL 1.0");

  /* inserting inline atomic triples (no variables) - not via template */
  (yyvsp[(6) - (7)].update)->graph_uri = (yyvsp[(2) - (7)].uri); /* graph uri */
  (yyvsp[(6) - (7)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(6) - (7)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;

  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(6) - (7)].update));
}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1431 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq,
                        "CLEAR GRAPH <uri> cannot be used with SPARQL 1.0");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CLEAR,
                                       (yyvsp[(3) - (3)].uri) /* graph uri or NULL */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("ClearQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("ClearQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1455 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq,
                        "CLEAR cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CLEAR is replaced by CLEAR GRAPH DEFAULT in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CLEAR,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("ClearQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("ClearQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1487 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE <uri> cannot be used with SPARQL 1.0");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(2) - (2)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1511 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE SILENT <uri> cannot be used with SPARQL 1.0");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1535 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE GRAPH <uri> cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CREATE GRAPH <uri> is replaced by CREATE <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1563 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE SILENT GRAPH <uri> cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CREATE SILENT GRAPH <uri> is replaced by CREATE SILENT <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(4) - (4)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1595 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP <uri> cannot be used with SPARQL 1.0");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                       (yyvsp[(2) - (2)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1619 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP SILENT <uri> cannot be used with SPARQL 1.0");


  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */);
  if(!update) {
    YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1644 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP GRAPH <uri> cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "DROP GRAPH <uri> is replaced by DROP <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1672 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP SILENT GRAPH <uri> cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "DROP SILENT GRAPH <uri> is replaced by DROP SILENT <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                       (yyvsp[(4) - (4)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */);
  if(!update) {
    YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1704 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].uri))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 1: sequence push failed");
  }
}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1713 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)raptor_free_uri,
                           (raptor_data_print_handler)raptor_uri_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)raptor_free_uri,
                           (raptor_sequence_print_handler*)raptor_uri_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].uri))
      raptor_free_uri((yyvsp[(1) - (1)].uri));
    YYERROR_MSG("IriRefList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].uri))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 2: sequence push failed");
  }
}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1737 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  int i;
  raptor_uri* doc_uri;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "LOAD <document uri> cannot be used with SPARQL 1.0");
  
  for(i = 0; (doc_uri = (raptor_uri*)raptor_sequence_get_at((yyvsp[(2) - (2)].seq), i)); i++) {
    rasqal_update_operation* update;
    update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_LOAD,
                                         NULL /* graph uri */, 
                                         raptor_uri_copy(doc_uri) /* document uri */,
                                         NULL, NULL,
                                         NULL /* where */,
                                         0 /* flags */);
    if(!update) {
      YYERROR_MSG("LoadQuery: rasqal_new_update_operation failed");
    } else {
      if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
        YYERROR_MSG("LoadQuery: rasqal_query_add_update_operation failed");
    }
  }

  raptor_free_sequence((yyvsp[(2) - (2)].seq));
}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1767 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  int i;
  raptor_uri* doc_uri;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update)
    sparql_syntax_error((rasqal_query*)rq, 
                        "LOAD <document uri> INTO <graph URI> cannot be used with SPARQL 1.0");

  for(i = 0; (doc_uri = (raptor_uri*)raptor_sequence_get_at((yyvsp[(2) - (4)].seq), i)); i++) {
    rasqal_update_operation* update;
    update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_LOAD,
                                         (yyvsp[(4) - (4)].uri) ? raptor_uri_copy((yyvsp[(4) - (4)].uri)) : NULL /* graph uri */,
                                         raptor_uri_copy(doc_uri) /* document uri */,
                                         NULL, NULL,
                                         NULL /*where */,
                                         0 /* flags */);
    if(!update) {
      YYERROR_MSG("LoadQuery: rasqal_new_update_operation failed");
    } else {
      if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
        YYERROR_MSG("LoadQuery: rasqal_query_add_update_operation failed");
    }
  }

  raptor_free_sequence((yyvsp[(2) - (4)].seq));
  if((yyvsp[(4) - (4)].uri))
    raptor_free_uri((yyvsp[(4) - (4)].uri));
}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1803 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(1) - (2)].seq) && (yyvsp[(2) - (2)].data_graph))
    raptor_sequence_push((yyvsp[(1) - (2)].seq), (yyvsp[(2) - (2)].data_graph));
}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1809 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_data_graph, (raptor_data_print_handler)rasqal_data_graph_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_data_graph, (raptor_sequence_print_handler*)rasqal_data_graph_print);
#endif
  if((yyval.seq) && (yyvsp[(1) - (1)].data_graph))
    raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].data_graph));
}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1822 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1826 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1834 "./sparql_parser.y"
    {
  if((yyvsp[(1) - (1)].literal)) {
    raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (1)].literal));
    rasqal_data_graph* dg;

    dg = rasqal_new_data_graph_from_uri(((rasqal_query*)rq)->world, uri,
                                        NULL, RASQAL_DATA_GRAPH_BACKGROUND,
                                        NULL, NULL, NULL);

    if(!dg) {
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
      YYERROR_MSG("DefaultGraphClause: rasqal_query_new_data_graph_from_uri() failed");
    }
    rasqal_free_literal((yyvsp[(1) - (1)].literal));

    (yyval.data_graph) = dg;
  } else
    (yyval.data_graph) = NULL;
}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1858 "./sparql_parser.y"
    {
  if((yyvsp[(2) - (2)].literal)) {
    raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(2) - (2)].literal));
    rasqal_data_graph* dg;

    dg = rasqal_new_data_graph_from_uri(((rasqal_query*)rq)->world, uri,
                                        uri, RASQAL_DATA_GRAPH_NAMED,
                                        NULL, NULL, NULL);
    
    if(!dg) {
      rasqal_free_literal((yyvsp[(2) - (2)].literal));
      YYERROR_MSG("NamedGraphClause: rasqal_query_new_data_graph_from_uri() failed");
    }
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
    (yyval.data_graph) = dg;
  } else
    (yyval.data_graph) = NULL;
}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1881 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1889 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (2)].graph_pattern);
}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1893 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1901 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1905 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = NULL;
}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1913 "./sparql_parser.y"
    {
  (yyval.modifier) = rasqal_new_solution_modifier((rasqal_query*)rq,
                                    /* order_conditions */ (yyvsp[(3) - (4)].seq),
                                    /* group_conditions */ (yyvsp[(1) - (4)].seq),
                                    /* having_conditions */ (yyvsp[(2) - (4)].seq),
                                    /* limit */ (yyvsp[(4) - (4)].limit_offset)[0],
                                    /* offset */ (yyvsp[(4) - (4)].limit_offset)[1]);
  
}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1927 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GroupConditionList 1: sequence push failed");
    }
}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1937 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("GroupConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GroupConditionList 2: sequence push failed");
    }
}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1962 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1966 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1970 "./sparql_parser.y"
    {
  if(rasqal_expression_mentions_variable((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].variable))) {
    sparql_query_error_full((rasqal_query*)rq, 
                            "Expression in GROUP BY ( expression ) AS %s contains the variable name '%s'",
                            (yyvsp[(4) - (5)].variable)->name, (yyvsp[(4) - (5)].variable)->name);
  } else {
    rasqal_literal* l;

    (yyvsp[(4) - (5)].variable)->expression = (yyvsp[(2) - (5)].expr);

    l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(4) - (5)].variable));
    if(!l)
      YYERROR_MSG("GroupCondition 4: cannot create lit");
    (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
    if(!(yyval.expr))
      YYERROR_MSG("GroupCondition 4: cannot create lit expr");
  }
  
}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1990 "./sparql_parser.y"
    {
  rasqal_literal* l;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("GroupCondition 5: cannot create lit");
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!(yyval.expr))
    YYERROR_MSG("GroupCondition 5: cannot create lit expr");
}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 2004 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  
  if(!sparql->sparql11_query)
    sparql_syntax_error((rasqal_query*)rq,
                        "GROUP BY cannot be used with SPARQL 1.0");
  else
    (yyval.seq) = (yyvsp[(3) - (3)].seq);
}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 2017 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 2025 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 2032 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("HavingConditionList 1: sequence push failed");
    }
}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 2042 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("HavingConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("HavingConditionList 2: sequence push failed");
    }
}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 2067 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  
  if(!sparql->sparql11_query)
    sparql_syntax_error((rasqal_query*)rq,
                        "HAVING cannot be used with SPARQL 1.0");
  else 
    (yyval.seq) = (yyvsp[(2) - (2)].seq);
}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 2080 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 2088 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = (yyvsp[(1) - (2)].integer);
  (yyval.limit_offset)[1] = (yyvsp[(2) - (2)].integer);
}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 2093 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = (yyvsp[(2) - (2)].integer);
  (yyval.limit_offset)[1] = (yyvsp[(1) - (2)].integer);
}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 2098 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = (yyvsp[(1) - (1)].integer);
  (yyval.limit_offset)[1] = -1;
}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 2103 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = -1;
  (yyval.limit_offset)[1] = (yyvsp[(1) - (1)].integer);
}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 2108 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = -1;
  (yyval.limit_offset)[1] = -1;
}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 2117 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(3) - (3)].seq);
}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 2121 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 2129 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("OrderConditionList 1: sequence push failed");
    }
}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 2139 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("OrderConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("OrderConditionList 2: sequence push failed");
    }
}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 2164 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 2171 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_DESC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 2: cannot create expr");
}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 2178 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 3: cannot create expr");
}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 2186 "./sparql_parser.y"
    {
  rasqal_literal* l;
  rasqal_expression *e;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("OrderCondition 4: cannot create lit");
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("OrderCondition 4: cannot create lit expr");

  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, e);
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 2203 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 5: cannot create expr");
}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 2211 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 6: cannot create expr");
}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 2223 "./sparql_parser.y"
    {
  (yyval.integer) = -1;

  if((yyvsp[(2) - (2)].literal) != NULL) {
    (yyval.integer) = (yyvsp[(2) - (2)].literal)->value.integer;
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
  }
  
}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 2237 "./sparql_parser.y"
    {
  (yyval.integer) = -1;

  if((yyvsp[(2) - (2)].literal) != NULL) {
    (yyval.integer) = (yyvsp[(2) - (2)].literal)->value.integer;
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
  }
}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 2250 "./sparql_parser.y"
    {
  if((yyvsp[(2) - (5)].seq)) {
    (yyval.bindings) = rasqal_new_bindings((rasqal_query*)rq, (yyvsp[(2) - (5)].seq), (yyvsp[(4) - (5)].seq));
    if(!(yyval.bindings))
      YYERROR_MSG("BindingsClauseOpt: cannot create bindings");
  } else {
    if((yyvsp[(4) - (5)].seq))
      raptor_free_sequence((yyvsp[(4) - (5)].seq));

    (yyval.bindings) = NULL;
  }
}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 2263 "./sparql_parser.y"
    {
  (yyval.bindings) = NULL;
}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 2271 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarList 1: sequence push failed");
  }
}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 2280 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_variable,
                           (raptor_data_print_handler)rasqal_variable_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_variable,
                           (raptor_sequence_print_handler*)rasqal_variable_print);
#endif
  if(!(yyval.seq))
    YYERROR_MSG("VarList 2: cannot create seq");

  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarList 3: sequence push failed");
  }
}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 2302 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 2306 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 2314 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].row))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("BindingsRowList 1: sequence push failed");
  } else {
    int size = raptor_sequence_size((yyval.seq));
    (yyvsp[(2) - (2)].row)->offset = size-1;
  }
}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 2326 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_row,
                           (raptor_data_print_handler)rasqal_row_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_row,
                           (raptor_sequence_print_handler*)rasqal_row_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].row))
      rasqal_free_row((yyvsp[(1) - (1)].row));

    YYERROR_MSG("BindingsRowList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].row))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("BindingsRowList 2: sequence push failed");
  }
}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 2351 "./sparql_parser.y"
    {
  (yyval.row) = NULL;
  if((yyvsp[(2) - (3)].seq)) {
    int size;
    rasqal_row* row;
    int i;
    
    size = raptor_sequence_size((yyvsp[(2) - (3)].seq));

    row = rasqal_new_row_for_size(((rasqal_query*)rq)->world, size);
    if(!row) {
      YYERROR_MSG("BindingsRow: cannot create row");
    } else {
      for(i = 0; i < size; i++) {
        rasqal_literal* value = raptor_sequence_delete_at((yyvsp[(2) - (3)].seq), i);
        rasqal_row_set_value_at(row, i, value);
      }
    }
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
    
    (yyval.row) = row;
  }
}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 2375 "./sparql_parser.y"
    {
  (yyval.row) = NULL;
}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 2383 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 1: sequence push failed");
  }
}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 2392 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_literal,
                           (raptor_data_print_handler)rasqal_literal_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_literal,
                           (raptor_sequence_print_handler*)rasqal_literal_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("IriRefList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 2: sequence push failed");
  }
}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 2416 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 2420 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 2424 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 2428 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 2432 "./sparql_parser.y"
    {
  (yyval.literal) = NULL;
}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 2443 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (3)].graph_pattern);
}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 2447 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (3)].graph_pattern);
}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 2458 "./sparql_parser.y"
    {
  rasqal_graph_pattern *formula_gp = NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GroupGraphPattern\n  TriplesBlockOpt=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphpatternListOpt=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  if(!(yyvsp[(1) - (2)].formula) && !(yyvsp[(2) - (2)].graph_pattern)) {
    (yyval.graph_pattern) = rasqal_new_2_group_graph_pattern((rasqal_query*)rq, NULL, NULL);
    if(!(yyval.graph_pattern))
      YYERROR_MSG("GroupGraphPattern: cannot create group gp");
  } else {
    if((yyvsp[(1) - (2)].formula)) {
      formula_gp = rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq,
                                                               (yyvsp[(1) - (2)].formula));
      if(!formula_gp) {
        if((yyvsp[(2) - (2)].graph_pattern))
          rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
        YYERROR_MSG("GroupGraphPattern: cannot create formula_gp");
      }
    }

    if((yyvsp[(2) - (2)].graph_pattern)) {
      (yyval.graph_pattern) = (yyvsp[(2) - (2)].graph_pattern);
      if(formula_gp && raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, formula_gp)) {
        rasqal_free_graph_pattern((yyval.graph_pattern));
        (yyval.graph_pattern) = NULL;
        YYERROR_MSG("GroupGraphPattern: sequence push failed");
      }
    } else
      (yyval.graph_pattern) = formula_gp;
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 2516 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlockOpt 1\n  TriplesBlock=");
  if((yyvsp[(1) - (1)].formula))
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 2529 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 2542 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListOpt\n  GraphPatternListOpt=");
  if((yyvsp[(1) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphPatternList=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) =  ((yyvsp[(1) - (2)].graph_pattern) ? (yyvsp[(1) - (2)].graph_pattern) : (yyvsp[(2) - (2)].graph_pattern));
  if((yyvsp[(1) - (2)].graph_pattern) && (yyvsp[(2) - (2)].graph_pattern)) {
    (yyval.graph_pattern) = (yyvsp[(1) - (2)].graph_pattern);
    if(rasqal_graph_patterns_join((yyval.graph_pattern), (yyvsp[(2) - (2)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      (yyval.graph_pattern) = NULL;
      YYERROR_MSG("GraphPatternListOpt: sequence join failed");
    }
    rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after grouping graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 2579 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 2583 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = NULL;
}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 2596 "./sparql_parser.y"
    {
  rasqal_graph_pattern *formula_gp = NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternList\n  GraphPatternListFilter=");
  if((yyvsp[(1) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].formula)) {
    formula_gp = rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq, 
                                                             (yyvsp[(3) - (3)].formula));
    if(!formula_gp) {
      if((yyvsp[(1) - (3)].graph_pattern))
        rasqal_free_graph_pattern((yyvsp[(1) - (3)].graph_pattern));
      YYERROR_MSG("GraphPatternList: cannot create formula_gp");
    }
  }
  (yyval.graph_pattern) = rasqal_new_2_group_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (3)].graph_pattern), formula_gp);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternList: cannot create sequence");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 2644 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 1\n  GraphPatternNotTriples=");
  if((yyvsp[(1) - (1)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (1)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 2657 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 2\n  Filter=");
  if((yyvsp[(1) - (1)].expr))
    rasqal_expression_print((yyvsp[(1) - (1)].expr), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = rasqal_new_filter_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (1)].expr));
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternListFilter 2: cannot create graph pattern");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 2691 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlock\n  TriplesSameSubject=");
  if((yyvsp[(1) - (3)].formula))
    rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  (yyval.formula) =  ((yyvsp[(1) - (3)].formula) ? (yyvsp[(1) - (3)].formula) : (yyvsp[(3) - (3)].formula));
  if((yyvsp[(1) - (3)].formula) && (yyvsp[(3) - (3)].formula)) {
    /* $1 and $3 are freed as necessary */
    (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (3)].formula), (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(1) - (3)].formula))
      YYERROR_MSG("TriplesBlock: formula join failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 2722 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 2730 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 2734 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 2738 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 2742 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 2746 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 2750 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 2758 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PatternElementForms 4\n  graphpattern=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = NULL;

  if((yyvsp[(2) - (2)].graph_pattern)) {
    raptor_sequence *seq;

#ifdef HAVE_RAPTOR2_API
    seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                              (raptor_data_print_handler)rasqal_graph_pattern_print);
#else
    seq = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern,
                              (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
#endif
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      YYERROR_MSG("OptionalGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(2) - (2)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("OptionalGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                    seq,
                                                    RASQAL_GRAPH_PATTERN_OPERATOR_OPTIONAL);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("OptionalGraphPattern: cannot create graph pattern");
      }
    }
  }
}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 2802 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern 2\n  varoruri=");
  rasqal_literal_print((yyvsp[(2) - (3)].literal), DEBUG_FH);
  fprintf(DEBUG_FH, ", graphpattern=");
  if((yyvsp[(3) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(3) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].graph_pattern)) {
    raptor_sequence *seq;

#ifdef HAVE_RAPTOR2_API
    seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                              (raptor_data_print_handler)rasqal_graph_pattern_print);
#else
    seq = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern,
                              (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
#endif
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(3) - (3)].graph_pattern));
      YYERROR_MSG("GraphGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(3) - (3)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("GraphGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                    seq,
                                                    RASQAL_GRAPH_PATTERN_OPERATOR_GRAPH);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("GraphGraphPattern: cannot create graph pattern");
        else
          rasqal_graph_pattern_set_origin((yyval.graph_pattern), (yyvsp[(2) - (3)].literal));
      }
    }
  }


#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  rasqal_free_literal((yyvsp[(2) - (3)].literal));
}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 2857 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = rasqal_new_single_graph_pattern((rasqal_query*)rq,
                                       RASQAL_GRAPH_PATTERN_OPERATOR_SERVICE,
                                       (yyvsp[(3) - (3)].graph_pattern));
  if((yyval.graph_pattern))
    (yyval.graph_pattern)->origin = (yyvsp[(2) - (3)].literal);
  else
    rasqal_free_literal((yyvsp[(2) - (3)].literal));
}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 2871 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = rasqal_new_single_graph_pattern((rasqal_query*)rq,
                                       RASQAL_GRAPH_PATTERN_OPERATOR_MINUS,
                                       (yyvsp[(2) - (2)].graph_pattern));
}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 2881 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(3) - (3)].graph_pattern);
  if(raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, (yyvsp[(1) - (3)].graph_pattern))) {
    rasqal_free_graph_pattern((yyval.graph_pattern));
    (yyval.graph_pattern) = NULL;
    YYERROR_MSG("GroupOrUnionGraphPattern: sequence push failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "UnionGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif
}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 2896 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 2903 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (3)].graph_pattern);
  if((yyvsp[(3) - (3)].graph_pattern))
    if(raptor_sequence_push((yyval.graph_pattern)->graph_patterns, (yyvsp[(3) - (3)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      (yyval.graph_pattern) = NULL;
      YYERROR_MSG("GroupOrUnionGraphPatternList 1: sequence push failed");
    }
}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 2913 "./sparql_parser.y"
    {
  raptor_sequence *seq;
#ifdef HAVE_RAPTOR2_API
  seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                            (raptor_data_print_handler)rasqal_graph_pattern_print);
#else
  seq = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern,
                            (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
#endif
  if(!seq) {
    if((yyvsp[(1) - (1)].graph_pattern))
      rasqal_free_graph_pattern((yyvsp[(1) - (1)].graph_pattern));
    YYERROR_MSG("GroupOrUnionGraphPatternList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].graph_pattern))
    if(raptor_sequence_push(seq, (yyvsp[(1) - (1)].graph_pattern))) {
      raptor_free_sequence(seq);
      YYERROR_MSG("GroupOrUnionGraphPatternList 2: sequence push failed");
    }
  (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                              seq,
                                              RASQAL_GRAPH_PATTERN_OPERATOR_UNION);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GroupOrUnionGraphPatternList 1: cannot create gp");
}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 2943 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if((yyvsp[(3) - (6)].variable) && (yyvsp[(5) - (6)].expr)) {
    if(sparql->experimental)
      (yyval.graph_pattern) = rasqal_new_let_graph_pattern((rasqal_query*)rq, (yyvsp[(3) - (6)].variable), (yyvsp[(5) - (6)].expr));
    else {
      sparql_syntax_error((rasqal_query*)rq,
                          "LET can only be used with LAQRS");
      rasqal_free_expression((yyvsp[(5) - (6)].expr));
      (yyval.graph_pattern) = NULL;
    }
  } else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 2964 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (2)].expr);
}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 2972 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 2976 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 2980 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 2987 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 2991 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 2999 "./sparql_parser.y"
    {
  raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (6)].literal));
  
  if(!(yyvsp[(4) - (6)].seq)) {
#ifdef HAVE_RAPTOR2_API
    (yyvsp[(4) - (6)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
#else
    (yyvsp[(4) - (6)].seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                             (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
    if(!(yyvsp[(4) - (6)].seq)) {
      rasqal_free_literal((yyvsp[(1) - (6)].literal));
      YYERROR_MSG("FunctionCall: cannot create sequence");
    }
  }

  uri = raptor_uri_copy(uri);

  if(raptor_sequence_size((yyvsp[(4) - (6)].seq)) == 1 &&
     rasqal_xsd_is_datatype_uri(((rasqal_query*)rq)->world, uri)) {
    rasqal_expression* e = (rasqal_expression*)raptor_sequence_pop((yyvsp[(4) - (6)].seq));
    (yyval.expr) = rasqal_new_cast_expression(((rasqal_query*)rq)->world, uri, e);
    if((yyval.expr))
      (yyval.expr)->flags |= (yyvsp[(3) - (6)].uinteger);
    raptor_free_sequence((yyvsp[(4) - (6)].seq));
  } else {
    unsigned int flags = 0;
    if((yyvsp[(3) - (6)].uinteger))
      flags |= 1;
    
    (yyval.expr) = rasqal_new_function_expression2(((rasqal_query*)rq)->world, 
                                         uri, (yyvsp[(4) - (6)].seq), (yyvsp[(5) - (6)].seq) /* params */,
                                         flags);
    if((yyval.expr))
      (yyval.expr)->flags |= (yyvsp[(3) - (6)].uinteger);
  }
  rasqal_free_literal((yyvsp[(1) - (6)].literal));

  if(!(yyval.expr))
    YYERROR_MSG("FunctionCall: cannot create expr");
}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 3043 "./sparql_parser.y"
    {
  raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (3)].literal));
  
  if(!(yyvsp[(2) - (3)].seq)) {
#ifdef HAVE_RAPTOR2_API
    (yyvsp[(2) - (3)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
#else
    (yyvsp[(2) - (3)].seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                             (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
    if(!(yyvsp[(2) - (3)].seq)) {
      rasqal_free_literal((yyvsp[(1) - (3)].literal));
      YYERROR_MSG("FunctionCall: cannot create sequence");
    }
  }

  uri = raptor_uri_copy(uri);

  if(raptor_sequence_size((yyvsp[(2) - (3)].seq)) == 1 &&
     rasqal_xsd_is_datatype_uri(((rasqal_query*)rq)->world, uri)) {
    rasqal_expression* e = (rasqal_expression*)raptor_sequence_pop((yyvsp[(2) - (3)].seq));
    (yyval.expr) = rasqal_new_cast_expression(((rasqal_query*)rq)->world, uri, e);
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  } else {
    (yyval.expr) = rasqal_new_function_expression2(((rasqal_query*)rq)->world,
                                         uri, (yyvsp[(2) - (3)].seq), NULL /* params */,
                                         0 /* flags */);
  }
  rasqal_free_literal((yyvsp[(1) - (3)].literal));

  if(!(yyval.expr))
    YYERROR_MSG("FunctionCall: cannot create expr");
}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 3082 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_query)
    sparql_syntax_error((rasqal_query*)rq,
                        "COALESCE cannote be used with SPARQL 1.0");

  if(!(yyvsp[(2) - (2)].seq)) {
#ifdef HAVE_RAPTOR2_API
    (yyvsp[(2) - (2)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
#else
    (yyvsp[(2) - (2)].seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                             (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
    if(!(yyvsp[(2) - (2)].seq))
      YYERROR_MSG("FunctionCall: cannot create sequence");
  }

  (yyval.expr) = rasqal_new_coalesce_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].seq));
  if(!(yyval.expr))
    YYERROR_MSG("Coalesce: cannot create expr");
}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 3111 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (3)].seq);
}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 3118 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if((yyvsp[(3) - (3)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ArgListNoBraces 1: sequence push failed");
    }
}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 3128 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("ArgListNoBraces 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ArgListNoBraces 2: sequence push failed");
    }
}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 3149 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 3157 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (3)].seq);
}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 3165 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 3169 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                           (raptor_data_print_handler)rasqal_triple_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                           (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
  if(!(yyval.seq)) {
    YYERROR_MSG("ConstructTriplesOpt: cannot create sequence");
  }
}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 3186 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
 
  if((yyvsp[(1) - (3)].formula)) {
    (yyval.seq) = (yyvsp[(1) - (3)].formula)->triples;
    (yyvsp[(1) - (3)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (3)].formula));
  }
  
  if((yyvsp[(3) - (3)].seq)) {
    if(!(yyval.seq)) {
#ifdef HAVE_RAPTOR2_API
      (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                               (raptor_data_print_handler)rasqal_triple_print);
#else
      (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                               (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
      if(!(yyval.seq)) {
        raptor_free_sequence((yyvsp[(3) - (3)].seq));
        YYERROR_MSG("ConstructTriples: cannot create sequence");
      }
    }

    if(raptor_sequence_join((yyval.seq), (yyvsp[(3) - (3)].seq))) {
      raptor_free_sequence((yyvsp[(3) - (3)].seq));
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ConstructTriples: sequence join failed");
    }
    raptor_free_sequence((yyvsp[(3) - (3)].seq));
  }

 }
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 3221 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
  
  if((yyvsp[(1) - (1)].formula)) {
    (yyval.seq) = (yyvsp[(1) - (1)].formula)->triples;
    (yyvsp[(1) - (1)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (1)].formula));
  }
  
}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 3236 "./sparql_parser.y"
    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 1\n  subject=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject = (yyvsp[(1) - (2)].formula)->value;
    int size = raptor_sequence_size(seq);
    
    /* non-empty property list, handle it  */
    for(i = 0; i < size; i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject = rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 1: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 3280 "./sparql_parser.y"
    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 2\n  TriplesNode=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject = (yyvsp[(1) - (2)].formula)->value;
    int size = raptor_sequence_size(seq);
    
    /* non-empty property list, handle it  */
    for(i = 0; i < size; i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject = rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 2: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 3328 "./sparql_parser.y"
    {
  int i;
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PropertyList 1\n  Verb=");
  rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  ObjectList=");
  rasqal_formula_print((yyvsp[(2) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  PropertyListTail=");
  if((yyvsp[(3) - (3)].formula) != NULL)
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif
  
  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, " empty ObjectList not processed\n");
#endif
  } else if((yyvsp[(1) - (3)].formula) && (yyvsp[(2) - (3)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (3)].formula)->triples;
    rasqal_literal *predicate = (yyvsp[(1) - (3)].formula)->value;
    rasqal_formula *formula;
    rasqal_triple *t2;
    int size;
    
    formula = rasqal_new_formula(((rasqal_query*)rq)->world);
    if(!formula) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create formula");
    }
#ifdef HAVE_RAPTOR2_API
    formula->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                           (raptor_data_print_handler)rasqal_triple_print);
#else
    formula->triples = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                                           (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
    if(!formula->triples) {
      rasqal_free_formula(formula);
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create sequence");
    }

    /* non-empty property list, handle it  */
    size = raptor_sequence_size(seq);
    for(i = 0; i < size; i++) {
      t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(!t2->predicate)
        t2->predicate = (rasqal_literal*)rasqal_new_literal_from_literal(predicate);
    }
  
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution ObjectList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    while(raptor_sequence_size(seq)) {
      t2 = (rasqal_triple*)raptor_sequence_unshift(seq);
      if(raptor_sequence_push(formula->triples, t2)) {
        rasqal_free_formula(formula);
        rasqal_free_formula((yyvsp[(1) - (3)].formula));
        rasqal_free_formula((yyvsp[(2) - (3)].formula));
        if((yyvsp[(3) - (3)].formula))
          rasqal_free_formula((yyvsp[(3) - (3)].formula));
        YYERROR_MSG("PropertyList 1: sequence push failed");
      }
    }

    (yyvsp[(3) - (3)].formula) = rasqal_formula_join(formula, (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(3) - (3)].formula)) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      YYERROR_MSG("PropertyList 1: formula join failed");
    }

#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after appending ObjectList=");
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif

    rasqal_free_formula((yyvsp[(2) - (3)].formula));
  }

  if((yyvsp[(1) - (3)].formula))
    rasqal_free_formula((yyvsp[(1) - (3)].formula));

  (yyval.formula) = (yyvsp[(3) - (3)].formula);
}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 3431 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(2) - (2)].formula);
}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 3435 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 3443 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 3447 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 3455 "./sparql_parser.y"
    {
  rasqal_formula *formula;
  rasqal_triple *triple;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "ObjectList 1\n");
  fprintf(DEBUG_FH, "  Object=\n");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  ObjectTail=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty ObjectTail\n");
#endif

  formula = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!formula) {
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create formula");
  }
  
#ifdef HAVE_RAPTOR2_API
  formula->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                         (raptor_data_print_handler)rasqal_triple_print);
#else
  formula->triples = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                                         (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
  if(!formula->triples) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create sequence");
  }

  triple = rasqal_new_triple(NULL, NULL, (yyvsp[(1) - (2)].formula)->value);
  (yyvsp[(1) - (2)].formula)->value = NULL; /* value now owned by triple */
  if(!triple) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create triple");
  }

  if(raptor_sequence_push(formula->triples, triple)) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: sequence push failed");
  }

  (yyval.formula) = rasqal_formula_join(formula, (yyvsp[(1) - (2)].formula));
  if(!(yyval.formula)) {
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: formula join $1 failed");
  }

  (yyval.formula) = rasqal_formula_join((yyval.formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("ObjectList: formula join $2 failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  objectList is now ");
  if((yyval.formula))
    raptor_sequence_print((yyval.formula)->triples, DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 3538 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(2) - (2)].formula);
}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 3542 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 3550 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 3558 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("Verb 1: cannot create formula");
  }
  (yyval.formula)->value = (yyvsp[(1) - (1)].literal);
}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 3568 "./sparql_parser.y"
    {
  raptor_uri *uri;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "verb Verb=rdf:type (a)\n");
#endif

#ifdef HAVE_RAPTOR2_API
  uri = raptor_new_uri_for_rdf_concept(((rasqal_query*)rq)->world->raptor_world_ptr,
                                       (const unsigned char*)"type");
#else
  uri = raptor_new_uri_for_rdf_concept("type");
#endif
  if(!uri)
    YYERROR_MSG("Verb 2: uri for rdf concept type failed");
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    raptor_free_uri(uri);
    YYERROR_MSG("Verb 2: cannot create formula");
  }
  (yyval.formula)->value = rasqal_new_uri_literal(((rasqal_query*)rq)->world, uri);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("Verb 2: cannot create uri literal");
  }
}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 3600 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 3604 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 3612 "./sparql_parser.y"
    {
  int i;
  const unsigned char *id;

  if((yyvsp[(2) - (3)].formula) == NULL) {
    (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
    if(!(yyval.formula))
      YYERROR_MSG("BlankNodePropertyList: cannot create formula");
  } else {
    (yyval.formula) = (yyvsp[(2) - (3)].formula);
    if((yyval.formula)->value) {
      rasqal_free_literal((yyval.formula)->value);
      (yyval.formula)->value = NULL;
    }
  }
  
  id = rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("BlankNodeProperyList: cannot create bnodeid");
  }

  (yyval.formula)->value = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                        RASQAL_LITERAL_BLANK, id);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("BlankNodePropertyList: cannot create literal");
  }

  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  } else {
    raptor_sequence *seq = (yyvsp[(2) - (3)].formula)->triples;

    /* non-empty property list, handle it  */
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    for(i = 0; i<raptor_sequence_size(seq); i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      
      t2->subject = (rasqal_literal*)rasqal_new_literal_from_literal((yyval.formula)->value);
    }

#if RASQAL_DEBUG > 1
    fprintf(DEBUG_FH, "  after substitution formula=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }
}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 3679 "./sparql_parser.y"
    {
  int i;
  rasqal_query* rdf_query = (rasqal_query*)rq;
  rasqal_literal* first_identifier = NULL;
  rasqal_literal* rest_identifier = NULL;
  rasqal_literal* object = NULL;
  rasqal_literal* blank = NULL;

#if RASQAL_DEBUG > 1
  char const *errmsg;
  #define YYERR_MSG_GOTO(label,msg) do { errmsg = msg; goto label; } while(0)
#else
  #define YYERR_MSG_GOTO(label,ignore) goto label
#endif

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "Collection\n  GraphNodeListNotEmpty=");
  raptor_sequence_print((yyvsp[(2) - (3)].seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif

  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula))
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create formula");

#ifdef HAVE_RAPTOR2_API
  (yyval.formula)->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                    (raptor_data_print_handler)rasqal_triple_print);
#else
  (yyval.formula)->triples = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                                    (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
  if(!(yyval.formula)->triples)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create sequence");

  first_identifier = rasqal_new_uri_literal(rdf_query->world,
                                            raptor_uri_copy(rdf_query->world->rdf_first_uri));
  if(!first_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot first_identifier");
  
  rest_identifier = rasqal_new_uri_literal(rdf_query->world,
                                           raptor_uri_copy(rdf_query->world->rdf_rest_uri));
  if(!rest_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create rest_identifier");
  
  object = rasqal_new_uri_literal(rdf_query->world,
                                  raptor_uri_copy(rdf_query->world->rdf_nil_uri));
  if(!object)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create nil object");

  for(i = raptor_sequence_size((yyvsp[(2) - (3)].seq))-1; i >= 0; i--) {
    rasqal_formula* f = (rasqal_formula*)raptor_sequence_get_at((yyvsp[(2) - (3)].seq), i);
    rasqal_triple *t2;
    const unsigned char *blank_id = NULL;

    blank_id = rasqal_query_generate_bnodeid(rdf_query, NULL);
    if(!blank_id)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnodeid");

    blank = rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_BLANK, blank_id);
    if(!blank)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnode");

    /* Move existing formula triples */
    if(f->triples)
      if(raptor_sequence_join((yyval.formula)->triples, f->triples))
        YYERR_MSG_GOTO(err_Collection, "Collection: sequence join failed");

    /* add new triples we needed */
    t2 = rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                           rasqal_new_literal_from_literal(first_identifier),
                           rasqal_new_literal_from_literal(f->value));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    t2 = rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                           rasqal_new_literal_from_literal(rest_identifier),
                           rasqal_new_literal_from_literal(object));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple 2");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: sequence push 2 failed");

    rasqal_free_literal(object);
    object=blank;
    blank = NULL;
  }

  /* free sequence of formulas just processed */
  raptor_free_sequence((yyvsp[(2) - (3)].seq));
  
  (yyval.formula)->value=object;
  
#if RASQAL_DEBUG > 1
  fprintf(DEBUG_FH, "  after substitution collection=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif

  rasqal_free_literal(first_identifier);
  rasqal_free_literal(rest_identifier);

  break; /* success */

  err_Collection:
  
  if(blank)
    rasqal_free_literal(blank);
  if(object)
    rasqal_free_literal(object);
  if(rest_identifier)
    rasqal_free_literal(rest_identifier);
  if(first_identifier)
    rasqal_free_literal(first_identifier);
  if((yyvsp[(2) - (3)].seq))
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  if((yyval.formula)) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 3811 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  char const *errmsg;

  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 1\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
  if((yyvsp[(1) - (2)].seq)) {
    fprintf(DEBUG_FH, "  GraphNodeListNotEmpty=");
    raptor_sequence_print((yyvsp[(1) - (2)].seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty GraphNodeListNotEmpty\n");
#endif

  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(!(yyval.seq)) {
#ifdef HAVE_RAPTOR2_API
    (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_formula,
                             (raptor_data_print_handler)rasqal_formula_print);
#else
    (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_formula,
                             (raptor_sequence_print_handler*)rasqal_formula_print);
#endif
    if(!(yyval.seq))
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty,
                     "GraphNodeListNotEmpty: cannot create formula");
  }
  
  if((yyvsp[(2) - (2)].formula)) {
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].formula))) {
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty,
                     "GraphNodeListNotEmpty 1: sequence push failed");
    }
    (yyvsp[(2) - (2)].formula) = NULL;
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  itemList is now ");
    raptor_sequence_print((yyval.seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }

  break; /* success */

  err_GraphNodeListNotEmpty:
  if((yyvsp[(2) - (2)].formula))
    rasqal_free_formula((yyvsp[(2) - (2)].formula));
  if((yyval.seq)) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 3869 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 2\n");
  if((yyvsp[(1) - (1)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
#endif

  if(!(yyvsp[(1) - (1)].formula))
    (yyval.seq) = NULL;
  else {
#ifdef HAVE_RAPTOR2_API
    (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_formula,
                             (raptor_data_print_handler)rasqal_formula_print);
#else
    (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_formula,
                             (raptor_sequence_print_handler*)rasqal_formula_print);
#endif
    if(!(yyval.seq)) {
      rasqal_free_formula((yyvsp[(1) - (1)].formula));
      YYERROR_MSG("GraphNodeListNotEmpty 2: cannot create sequence");
    }
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].formula))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GraphNodeListNotEmpty 2: sequence push failed");
    }
  }
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  GraphNodeListNotEmpty is now ");
  raptor_sequence_print((yyval.seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 3911 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 3915 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 3923 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula))
    YYERROR_MSG("VarOrTerm 1: cannot create formula");
  (yyval.formula)->value = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("VarOrTerm 1: cannot create literal");
  }
}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 3935 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("VarOrTerm 2: cannot create formula");
  }
  (yyval.formula)->value = (yyvsp[(1) - (1)].literal);
}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 3948 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.literal))
    YYERROR_MSG("VarOrIRIref: cannot create literal");
}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 3954 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 3962 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 3966 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 3973 "./sparql_parser.y"
    {
  (yyval.variable) = rasqal_variables_table_add(((rasqal_query*)rq)->vars_table,
                                  RASQAL_VARIABLE_TYPE_NORMAL, (yyvsp[(1) - (1)].name), NULL);
  if(!(yyval.variable))
    YYERROR_MSG("VarName: cannot create var");
}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 3984 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 3988 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 3992 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(1) - (1)].variable);
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "... AS varname is deprecated LAQRS syntax, use ... AS ?varname");
}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 4002 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 4006 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 4010 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 4014 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 4018 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 4022 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, 
                              raptor_uri_copy(((rasqal_query*)rq)->world->rdf_nil_uri));
  if(!(yyval.literal))
    YYERROR_MSG("GraphTerm: cannot create literal");
}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 4032 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 4040 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_OR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalOrExpression: cannot create expr");
}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 4047 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 4055 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_AND, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalAndExpression: cannot create expr");
;
}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 4063 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 4072 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_EQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 1: cannot create expr");
}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 4079 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_NEQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 2: cannot create expr");
}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 4086 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 3: cannot create expr");
}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 4093 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_GT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 4: cannot create expr");
}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 4100 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 5: cannot create expr");
}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 4107 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_GE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 6: cannot create expr");
}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 4114 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_set_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_IN, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].seq));
}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 4119 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_set_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_NOT_IN, (yyvsp[(1) - (4)].expr), (yyvsp[(4) - (4)].seq));
}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 4124 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 4133 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 1: cannot create expr");
}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 4140 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_MINUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 2: cannot create expr");
}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 4147 "./sparql_parser.y"
    {
  rasqal_expression *e;
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 3: cannot create expr");
  }
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 4: cannot create expr");
}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 4160 "./sparql_parser.y"
    {
  rasqal_expression *e;
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 5: cannot create expr");
  }
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 6: cannot create expr");
}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 4173 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 4180 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STAR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 1: cannot create expr");
}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 4187 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SLASH, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 2: cannot create expr");
}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 4194 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 4202 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_BANG, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 1: cannot create expr");
}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 4209 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (2)].expr);
}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 4213 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_UMINUS, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 3: cannot create expr");
}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 4220 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 4234 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 4238 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 4242 "./sparql_parser.y"
    {
  /* Grammar has IRIrefOrFunction here which is "IRIref ArgList?"
   * and essentially shorthand for FunctionCall | IRIref.  The Rasqal
   * SPARQL lexer distinguishes these for us with IRIrefBrace.
   * IRIref is covered below by GraphTerm.
   */
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 4251 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].literal));
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 4: cannot create expr");
}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 4257 "./sparql_parser.y"
    {
  rasqal_literal *l;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("PrimaryExpression 5: cannot create literal");
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 5: cannot create expr");
}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 4267 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 4275 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (3)].expr);
}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 4283 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STR, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 1: cannot create expr");
}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 4290 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LANG, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 2: cannot create expr");
}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 4297 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LANGMATCHES, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 3: cannot create expr");
}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 4304 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_DATATYPE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 4: cannot create expr");
}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 4311 "./sparql_parser.y"
    {
  rasqal_literal *l;
  rasqal_expression *e;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(3) - (4)].variable));
  if(!l)
    YYERROR_MSG("BuiltInCall 5: cannot create literal");
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("BuiltInCall 6: cannot create literal expr");
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_BOUND, e);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7: cannot create expr");
}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 4326 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_IRI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7a: cannot create expr");
}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 4333 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_IRI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7b: cannot create expr");
}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 4340 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_BNODE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7c: cannot create expr");
}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 4347 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_BNODE, NULL);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7d: cannot create expr");
}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 4354 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 4358 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_IF, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7e: cannot create expr");
}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 4365 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRLANG, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7f: cannot create expr");
}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 4372 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRDT, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7g: cannot create expr");
}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 4379 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SAMETERM, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 8: cannot create expr");
}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 4386 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISURI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 9: cannot create expr");
}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 4393 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISBLANK, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 10: cannot create expr");
}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 4400 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISLITERAL, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 11: cannot create expr");
}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 4407 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISLITERAL, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 11: cannot create expr");
}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 4414 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 4422 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REGEX, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr), NULL);
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 1: cannot create expr");
}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 4429 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REGEX, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 2: cannot create expr");
}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 4443 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 1: cannot create literal");
}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 4449 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal) = NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 4469 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 4473 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 4477 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 4484 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 4488 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 4492 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 4500 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 4504 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 4508 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 4516 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 4520 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 4524 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 4536 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 1: cannot create literal");
}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 4542 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal) = NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 4562 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_BLANK, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 1: cannot create literal");
}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 4568 "./sparql_parser.y"
    {
  const unsigned char *id;
  id = rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id)
    YYERROR_MSG("BlankNode 2: cannot create bnodeid");
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_BLANK, id);
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 2: cannot create literal");
}
    break;



/* Line 1455 of yacc.c  */
#line 9031 "sparql_parser.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 4587 "./sparql_parser.y"



/* Support functions */


/* This is declared in sparql_lexer.h but never used, so we always get
 * a warning unless this dummy code is here.  Used once below in an error case.
 */
static int yy_init_globals (yyscan_t yyscanner ) { return 0; }


/**
 * rasqal_sparql_query_language_init - Initialise the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static int
rasqal_sparql_query_language_init(rasqal_query* rdf_query, const char *name)
{
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rdf_query->context;

  rdf_query->compare_flags = RASQAL_COMPARE_XQUERY;

  /* All the sparql query families support this */
  rqe->sparql10 = 1;

  /* SPARQL 1.1 */
  if(!strcmp(name, "sparql11") || !strcmp(name, "laqrs")) {
    rqe->sparql11_query = 1;
    rqe->sparql11_aggregates = 1;
    rqe->sparql11_property_paths = 1;
    rqe->sparql11_update = 1;
  }

  /* LAQRS for experiments */
  if(!strcmp(name, "laqrs"))
    rqe->experimental = 1;

  return 0;
}


/**
 * rasqal_sparql_query_language_terminate - Free the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static void
rasqal_sparql_query_language_terminate(rasqal_query* rdf_query)
{
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)rdf_query->context;

  if(sparql && sparql->scanner_set) {
    sparql_lexer_lex_destroy(sparql->scanner);
    sparql->scanner_set = 0;
  }

}


static int
rasqal_sparql_query_language_prepare(rasqal_query* rdf_query)
{
  /* rasqal_sparql_query_language* sparql = (rasqal_sparql_query_language*)rdf_query->context; */
  int rc;
  
  if(!rdf_query->query_string)
    return 1;
  
  rc=sparql_parse(rdf_query);
  if(rc)
    return rc;

  /* FIXME - should check remaining query parts  */
  if(rasqal_sequence_has_qname(rdf_query->triples) ||
     rasqal_sequence_has_qname(rdf_query->constructs) ||
     rasqal_query_constraints_has_qname(rdf_query)) {
    sparql_query_error(rdf_query, "SPARQL query has unexpanded QNames");
    return 1;
  }

  /* SPARQL: Turn [] into anonymous variables */
  if(rasqal_query_build_anonymous_variables(rdf_query))
    return 1;
  
  /* SPARQL: Expand 'SELECT *' */
  if(rasqal_query_expand_wildcards(rdf_query))
    return 1;
  
  return 0;
}


static int
sparql_parse(rasqal_query* rq)
{
  rasqal_sparql_query_language* rqe;
  raptor_locator *locator=&rq->locator;
  void *buffer;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(!rq->query_string)
    return yy_init_globals(NULL); /* 0 but a way to use yy_init_globals */

  locator->line = 1;
  locator->column = -1; /* No column info */
  locator->byte = -1; /* No bytes info */

#if RASQAL_DEBUG > 2
  sparql_parser_debug = 1;
#endif

  rqe->lineno = 1;

  if(sparql_lexer_lex_init(&rqe->scanner))
    return 1;
  rqe->scanner_set = 1;

  sparql_lexer_set_extra(((rasqal_query*)rq), rqe->scanner);

  buffer = sparql_lexer__scan_buffer((char*)rq->query_string,
                                     rq->query_string_length, rqe->scanner);

  rqe->error_count = 0;

  sparql_parser_parse(rq);

  sparql_lexer_lex_destroy(rqe->scanner);
  rqe->scanner_set = 0;

  /* Parsing failed */
  if(rq->failed)
    return 1;
  
  return 0;
}


static void
sparql_query_error(rasqal_query *rq, const char *msg)
{
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column = sparql_lexer_get_column(yyscanner);*/
#endif

  rq->failed = 1;
  rasqal_log_error_simple(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                          &rq->locator, "%s", msg);
}


static void
sparql_query_error_full(rasqal_query *rq, const char *message, ...)
{
  va_list arguments;
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column = sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);

  rq->failed = 1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                           &rq->locator, message, arguments);

  va_end(arguments);
}


int
sparql_syntax_error(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe;
  va_list arguments;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return 0;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rp->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rq->failed = 1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                           &rq->locator, message, arguments);
  va_end(arguments);

  return 0;
}


int
sparql_syntax_warning(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe;
  va_list arguments;

  rqe = (rasqal_sparql_query_language*)rq->context;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rasqal_log_error_varargs(((rasqal_query*)rq)->world,
                           RAPTOR_LOG_LEVEL_WARN,
                           &rq->locator, message,
                           arguments);
  va_end(arguments);

  return (0);
}


static int
rasqal_sparql_query_language_iostream_write_escaped_counted_string(rasqal_query* query,
                                                                   raptor_iostream* iostr,
                                                                   const unsigned char* string,
                                                                   size_t len)
{
  const char delim = '"';
  
  raptor_iostream_write_byte(delim, iostr);
  if(raptor_string_ntriples_write(string, len, delim, iostr))
    return 1;
  
  raptor_iostream_write_byte(delim, iostr);

  return 0;
}


static const char* const sparql_names[3] = { "sparql", "sparql10", NULL};

#define SPARQL_TYPES_COUNT 1
static const raptor_type_q sparql_types[SPARQL_TYPES_COUNT + 1] = {
  { "application/sparql", 18, 10}, 
  { NULL, 0, 0}
};


static int
rasqal_sparql_query_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql_names;

  factory->desc.mime_types = sparql_types;
  factory->desc.mime_types_count = SPARQL_TYPES_COUNT;

  factory->desc.label = "SPARQL 1.0 W3C RDF Query Language";

  factory->desc.uri_string = "http://www.w3.org/TR/rdf-sparql-query/";

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


int
rasqal_init_query_language_sparql(rasqal_world* world)
{
  return !rasqal_query_language_register_factory(world,
                                                 &rasqal_sparql_query_language_register_factory);
}


static const char* const sparql11_names[4] = { "sparql11", NULL};

#define SPARQL11_TYPES_COUNT 0
static const raptor_type_q sparql11_types[SPARQL11_TYPES_COUNT + 1] = {
  { NULL, 0, 0}
};


static int
rasqal_sparql11_query_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql11_names;

  factory->desc.mime_types = sparql11_types;
  factory->desc.mime_types_count = SPARQL11_TYPES_COUNT;

  factory->desc.label = "SPARQL 1.1 (DRAFT) Query Language";

  factory->desc.uri_string = "http://www.w3.org/TR/2010/WD-sparql11-query-20100601/";

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


int
rasqal_init_query_language_sparql11(rasqal_world* world)
{
  return !rasqal_query_language_register_factory(world,
                                                 &rasqal_sparql11_query_language_register_factory);
}


static const char* const laqrs_names[3] = { "laqrs", NULL};

#define LAQRS_TYPES_COUNT 0
static const raptor_type_q laqrs_types[LAQRS_TYPES_COUNT + 1] = {
  { NULL, 0, 0}
};


static int
rasqal_laqrs_query_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = laqrs_names;

  factory->desc.mime_types = laqrs_types;
  factory->desc.mime_types_count = LAQRS_TYPES_COUNT;

  factory->desc.label = "LAQRS adds to Querying RDF in SPARQL";

  factory->desc.uri_string = NULL;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


int
rasqal_init_query_language_laqrs(rasqal_world* world)
{
  return !rasqal_query_language_register_factory(world,
                                                 &rasqal_laqrs_query_language_register_factory);
}


#ifdef STANDALONE
#include <stdio.h>
#include <locale.h>
#ifdef HAVE_GETOPT_H
#include <getopt.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifndef HAVE_GETOPT
#include <rasqal_getopt.h>
#endif

#ifdef NEED_OPTIND_DECLARATION
extern int optind;
extern char *optarg;
#endif

#define GETOPT_STRING "di:"

#define SPARQL_FILE_BUF_SIZE 2048

int
main(int argc, char *argv[]) 
{
  const char *program = rasqal_basename(argv[0]);
  char query_string[SPARQL_FILE_BUF_SIZE];
  rasqal_query *query;
  FILE *fh;
  int rc;
  const char *filename = NULL;
  raptor_uri* base_uri = NULL;
  unsigned char *uri_string = NULL;
  const char* query_language = "sparql";
  int usage = 0;
  rasqal_world *world;
  
  world = rasqal_new_world();
  if(!world || rasqal_world_open(world))
    exit(1);

  filename = getenv("SPARQL_QUERY_FILE");
    
  while(!usage) {
    int c = getopt (argc, argv, GETOPT_STRING);

    if (c == -1)
      break;

    switch (c) {
      case 0:
      case '?': /* getopt() - unknown option */
        usage = 1;
        break;
        
      case 'd':
#if RASQAL_DEBUG > 2
        sparql_parser_debug = 1;
#endif
        break;
  
      case 'i':
        if(optarg) {
          if(rasqal_language_name_check(world, optarg)) {
            query_language = optarg;
          } else {
            fprintf(stderr, "%s: Unknown query language '%s'\n",
                    program, optarg);
            usage = 1;
          }
        }
        break;
    }
  }

  if(!filename) {
    if((argc-optind) != 1) {
      fprintf(stderr, "%s: Too many arguments.\n", program);
      usage = 1;
    } else
      filename = argv[optind];
  }
  
  if(usage) {
    fprintf(stderr, "SPARQL/LAQRS parser test for Rasqal %s\n", 
            rasqal_version_string);
    fprintf(stderr, "USAGE: %s [OPTIONS] SPARQL-QUERY-FILE\n", program);
    fprintf(stderr, "OPTIONS:\n");
#if RASQAL_DEBUG > 2
    fprintf(stderr, " -d           Bison parser debugging\n");
#endif
    fprintf(stderr, " -i LANGUAGE  Set query language\n");
    rc = 1;
    goto tidy;
  }


 fh = fopen(filename, "r");
 if(!fh) {
   fprintf(stderr, "%s: Cannot open file %s - %s\n", program, filename,
           strerror(errno));
   rc = 1;
   goto tidy;
 }
 
  memset(query_string, 0, SPARQL_FILE_BUF_SIZE);
  rc=fread(query_string, SPARQL_FILE_BUF_SIZE, 1, fh);
  if(rc < SPARQL_FILE_BUF_SIZE) {
    if(ferror(fh)) {
      fprintf(stderr, "%s: file '%s' read failed - %s\n",
              program, filename, strerror(errno));
      fclose(fh);
      rc = 1;
      goto tidy;
    }
  }
  
  fclose(fh);

  query = rasqal_new_query(world, query_language, NULL);
  rc = 1;
  if(query) {
    uri_string = raptor_uri_filename_to_uri_string(filename);

    if(uri_string) {
      base_uri = raptor_new_uri(world->raptor_world_ptr, uri_string);

      if(base_uri) {
        rc = rasqal_query_prepare(query, (const unsigned char*)query_string, 
                                  base_uri);

        if(!rc)
          rasqal_query_print(query, stdout);
      }
    }
  }

  tidy:
  if(query)
    rasqal_free_query(query);

  if(base_uri)
    raptor_free_uri(base_uri);

  if(uri_string)
    raptor_free_memory(uri_string);

  if(world)
    rasqal_free_world(world);

  return rc;
}
#endif

